<?php
/*
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.

   ---------------------------------------------------------------------
   Gerrit Bouweriks
   OpenCart 1.5.1.x Dutch PostNL module 1.5.1.x
   Special thank you goes to
   SuperJuice (Sam), for conversions made to weight en length classes
   Sanne for testing and Norman for the translations
   Petran for mailbox option
*/
class ControllerShippingPOSTNL extends Controller {
	private $error = array();

	public function index() {
		$this->load->language('shipping/postnl');

		$this->document->setTitle = $this->language->get('heading_title');

		$this->load->model('setting/setting');

		if (($this->request->server['REQUEST_METHOD'] == 'POST') && ($this->validate())) {
			$this->model_setting_setting->editSetting('postnl', $this->request->post);

			$this->session->data['success'] = $this->language->get('text_success');

			$this->redirect($this->url->link('extension/shipping', 'token=' . $this->session->data['token'], 'SSL'));
		}

		$this->data['heading_title'] = $this->language->get('heading_title');

		$this->data['text_enabled'] = $this->language->get('text_enabled');
		$this->data['text_disabled'] = $this->language->get('text_disabled');
		$this->data['text_all_zones'] = $this->language->get('text_all_zones');
		$this->data['text_none'] = $this->language->get('text_none');
		$this->data['text_yes'] = $this->language->get('text_yes');
		$this->data['text_no'] = $this->language->get('text_no');
		$this->data['text_countries'] = $this->language->get('text_countries');
		$this->data['text_countries_rest'] = $this->language->get('text_countries_rest');
		$this->data['text_winkel'] = $this->language->get('text_winkel');


		$this->data['tab_briefpost'] = $this->language->get('tab_briefpost');
		$this->data['tab_nederland'] = $this->language->get('tab_nederland');
		$this->data['tab_europa_1'] = $this->language->get('tab_europa_1');
		$this->data['tab_europa_2'] = $this->language->get('tab_europa_2');
		$this->data['tab_europa_3'] = $this->language->get('tab_europa_3');
		$this->data['tab_wereld'] = $this->language->get('tab_wereld');

		$this->data['entry_postnl_briefpost_nl'] = $this->language->get('entry_postnl_briefpost_nl');
		$this->data['entry_postnl_briefpost_aangetekend_nl'] = $this->language->get('entry_postnl_briefpost_aangetekend_nl');
		$this->data['entry_postnl_briefpost_rembours_nl'] = $this->language->get('entry_postnl_briefpost_rembours_nl');

		$this->data['entry_postnl_briefpost_eu'] = $this->language->get('entry_postnl_briefpost_eu');
		$this->data['entry_postnl_briefpost_aangetekend_eu'] = $this->language->get('entry_postnl_briefpost_aangetekend_eu');

		$this->data['entry_postnl_briefpost_row'] = $this->language->get('entry_postnl_briefpost_row');
		$this->data['entry_postnl_briefpost_aangetekend_row'] = $this->language->get('entry_postnl_briefpost_aangetekend_row');


		$this->data['entry_postnl_nl'] = $this->language->get('entry_postnl_nl');
		$this->data['entry_postnl_nl_aantekenen'] = $this->language->get('entry_postnl_nl_aantekenen');
		$this->data['entry_postnl_nl_verzekerd'] = $this->language->get('entry_postnl_nl_verzekerd');
		$this->data['entry_postnl_nl_rembours'] = $this->language->get('entry_postnl_nl_rembours');
		$this->data['entry_postnl_nl_spoed'] = $this->language->get('entry_postnl_nl_spoed');

		$this->data['entry_postnl_eu1'] = $this->language->get('entry_postnl_eu1');
		$this->data['entry_postnl_eu1_aantekenen'] = $this->language->get('entry_postnl_eu1_aantekenen');
		$this->data['entry_postnl_eu1_verzekerd'] = $this->language->get('entry_postnl_eu1_verzekerd');
		$this->data['entry_postnl_eu1_spoed'] = $this->language->get('entry_postnl_eu1_spoed');

		$this->data['entry_postnl_eu2'] = $this->language->get('entry_postnl_eu2');
		$this->data['entry_postnl_eu2_aantekenen'] = $this->language->get('entry_postnl_eu2_aantekenen');
		$this->data['entry_postnl_eu2_verzekerd'] = $this->language->get('entry_postnl_eu2_verzekerd');
		$this->data['entry_postnl_eu2_spoed'] = $this->language->get('entry_postnl_eu2_spoed');

		$this->data['entry_postnl_eu3'] = $this->language->get('entry_postnl_eu3');
		$this->data['entry_postnl_eu3_aantekenen'] = $this->language->get('entry_postnl_eu3_aantekenen');
		$this->data['entry_postnl_eu3_verzekerd'] = $this->language->get('entry_postnl_eu3_verzekerd');

		$this->data['entry_postnl_wereld'] = $this->language->get('entry_postnl_wereld');
		$this->data['entry_postnl_wereld_aantekenen'] = $this->language->get('entry_postnl_wereld_aantekenen');
		$this->data['entry_postnl_wereld_verzekerd'] = $this->language->get('entry_postnl_wereld_verzekerd');

		$this->data['entry_service'] = $this->language->get('entry_service');
		$this->data['entry_display_weight'] = $this->language->get('entry_display_weight');
		$this->data['entry_display_insurance'] = $this->language->get('entry_display_insurance');
		$this->data['entry_display_time'] = $this->language->get('entry_display_time');
		$this->data['entry_use_freeshipping'] = $this->language->get('entry_use_freeshipping');
		$this->data['entry_tax'] = $this->language->get('entry_tax');
		$this->data['entry_geo_zone'] = $this->language->get('entry_geo_zone');
		$this->data['entry_status'] = $this->language->get('entry_status');
		$this->data['entry_sort_order'] = $this->language->get('entry_sort_order');
		$this->data['entry_max_briefwaarde'] = $this->language->get('entry_max_briefwaarde');
		$this->data['entry_max_pakketwaarde'] = $this->language->get('entry_max_pakketwaarde');

		$this->data['entry_discount_nl_mail'] = $this->language->get('entry_discount_nl_mail');
		$this->data['entry_discount_eu1_mail'] = $this->language->get('entry_discount_eu1_mail');
		$this->data['entry_discount_eu2_mail'] = $this->language->get('entry_discount_eu2_mail');
		$this->data['entry_discount_eu3_mail'] = $this->language->get('entry_discount_eu3_mail');
		$this->data['entry_discount_world_mail'] = $this->language->get('entry_discount_world_mail');

		$this->data['entry_discount_nl_parcel'] = $this->language->get('entry_discount_nl_parcel');
		$this->data['entry_discount_eu1_parcel'] = $this->language->get('entry_discount_eu1_parcel');
		$this->data['entry_discount_eu2_parcel'] = $this->language->get('entry_discount_eu2_parcel');
		$this->data['entry_discount_eu3_parcel'] = $this->language->get('entry_discount_eu3_parcel');
		$this->data['entry_discount_world_parcel'] = $this->language->get('entry_discount_world_parcel');

		$this->data['button_save'] = $this->language->get('button_save');
		$this->data['button_cancel'] = $this->language->get('button_cancel');

		$this->data['tab_general'] = $this->language->get('tab_general');

		$this->data['tab_general_settings'] = $this->language->get('tab_general_settings');
		$this->data['tab_general_discount'] = $this->language->get('tab_general_discount');
		$this->data['tab_general_discount_parcel'] = $this->language->get('tab_general_discount_parcel');
		$this->data['tab_general_shipping'] = $this->language->get('tab_general_shipping');

		// shippingboxes
		$this->data['text_display_letterbox_a4'] = $this->language->get('text_display_letterbox_a4');
		$this->data['entry_display_letterbox_big'] = $this->language->get('entry_display_letterbox_big');
		$this->data['entry_display_letterbox_small'] = $this->language->get('entry_display_letterbox_small');
		$this->data['entry_display_bubble_small'] = $this->language->get('entry_display_bubble_small');
		$this->data['entry_display_bubble_medium'] = $this->language->get('entry_display_bubble_medium');
		$this->data['entry_display_bubble_big'] = $this->language->get('entry_display_bubble_big');
		$this->data['entry_display_noletterbox'] = $this->language->get('entry_display_noletterbox');

		$this->data['text_display_cardbox'] = $this->language->get('text_display_cardbox');
		$this->data['entry_display_cardbox_small'] = $this->language->get('entry_display_cardbox_small');
		$this->data['entry_display_cardbox_big'] = $this->language->get('entry_display_cardbox_big');
		$this->data['entry_display_cardbox_medium'] = $this->language->get('entry_display_cardbox_medium');
		$this->data['entry_display_nocardbox'] = $this->language->get('entry_display_nocardbox');

		// Placeholder text files
		$this->data['ph_standard'] = $this->language->get('ph_standard');
		$this->data['ph_ensured'] = $this->language->get('ph_ensured');
		$this->data['ph_registered'] = $this->language->get('ph_registered');
		$this->data['ph_rush'] = $this->language->get('ph_rush');
		$this->data['ph_pod'] = $this->language->get('ph_pod');
		$this->data['ph_amount'] = $this->language->get('ph_amount');


		if (isset($this->error['warning'])) {
			$this->data['error_warning'] = $this->error['warning'];
		} else {
			$this->data['error_warning'] = '';
		}

		$this->data['breadcrumbs'] = array();

		$this->data['breadcrumbs'][] = array(
       		'text'      => $this->language->get('text_home'),
			'href'      => $this->url->link('common/home', 'token=' . $this->session->data['token'], 'SSL'),
      		'separator' => false
   		);

		$this->data['breadcrumbs'][] = array(
       		'text'      => $this->language->get('text_shipping'),
			'href'      => $this->url->link('extension/shipping', 'token=' . $this->session->data['token'], 'SSL'),
      		'separator' => ' :: '
   		);

		$this->data['breadcrumbs'][] = array(
       		'text'      => $this->language->get('heading_title'),
			'href'      => $this->url->link('shipping/postnl', 'token=' . $this->session->data['token'], 'SSL'),
      		'separator' => ' :: '
   		);

		$this->data['action'] = $this->url->link('shipping/postnl', 'token=' . $this->session->data['token'], 'SSL');

		$this->data['cancel'] = $this->url->link('extension/shipping', 'token=' . $this->session->data['token'], 'SSL');

		// Brief Post
		// Nederland
		if (isset($this->request->post['postnl_briefpost_nl_20'])) {
			$this->data['postnl_briefpost_nl_20'] = $this->request->post['postnl_briefpost_nl_20'];
		} else {
			$this->data['postnl_briefpost_nl_20'] = $this->config->get('postnl_briefpost_nl_20');
		}

		if (isset($this->request->post['postnl_briefpost_nl_50'])) {
			$this->data['postnl_briefpost_nl_50'] = $this->request->post['postnl_briefpost_nl_50'];
		} else {
			$this->data['postnl_briefpost_nl_50'] = $this->config->get('postnl_briefpost_nl_50');
		}

		if (isset($this->request->post['postnl_briefpost_nl_100'])) {
			$this->data['postnl_briefpost_nl_100'] = $this->request->post['postnl_briefpost_nl_100'];
		} else {
			$this->data['postnl_briefpost_nl_100'] = $this->config->get('postnl_briefpost_nl_100');
		}

		if (isset($this->request->post['postnl_briefpost_nl_250'])) {
			$this->data['postnl_briefpost_nl_250'] = $this->request->post['postnl_briefpost_nl_250'];
		} else {
			$this->data['postnl_briefpost_nl_250'] = $this->config->get('postnl_briefpost_nl_250');
		}

		if (isset($this->request->post['postnl_briefpost_nl_500'])) {
			$this->data['postnl_briefpost_nl_500'] = $this->request->post['postnl_briefpost_nl_500'];
		} else {
			$this->data['postnl_briefpost_nl_500'] = $this->config->get('postnl_briefpost_nl_500');
		}

		if (isset($this->request->post['postnl_briefpost_nl_2000'])) {
			$this->data['postnl_briefpost_nl_2000'] = $this->request->post['postnl_briefpost_nl_2000'];
		} else {
			$this->data['postnl_briefpost_nl_2000'] = $this->config->get('postnl_briefpost_nl_2000');
		}

		// Briefpost Aangetekend NL
		if (isset($this->request->post['postnl_briefpost_aantekenen_nl_2000'])) {
			$this->data['postnl_briefpost_aantekenen_nl_2000'] = $this->request->post['postnl_briefpost_aantekenen_nl_2000'];
		} else {
			$this->data['postnl_briefpost_aantekenen_nl_2000'] = $this->config->get('postnl_briefpost_aantekenen_nl_2000');
		}

		// Briefpost Rembours NL
		if (isset($this->request->post['postnl_briefpost_rembours_nl_2000'])) {
			$this->data['postnl_briefpost_rembours_nl_2000'] = $this->request->post['postnl_briefpost_rembours_nl_2000'];
		} else {
			$this->data['postnl_briefpost_rembours_nl_2000'] = $this->config->get('postnl_briefpost_rembours_nl_2000');
		}

		// Europa
		if (isset($this->request->post['postnl_briefpost_eu_20'])) {
			$this->data['postnl_briefpost_eu_20'] = $this->request->post['postnl_briefpost_eu_20'];
		} else {
			$this->data['postnl_briefpost_eu_20'] = $this->config->get('postnl_briefpost_eu_20');
		}

		if (isset($this->request->post['postnl_briefpost_eu_50'])) {
			$this->data['postnl_briefpost_eu_50'] = $this->request->post['postnl_briefpost_eu_50'];
		} else {
			$this->data['postnl_briefpost_eu_50'] = $this->config->get('postnl_briefpost_eu_50');
		}

		if (isset($this->request->post['postnl_briefpost_eu_100'])) {
			$this->data['postnl_briefpost_eu_100'] = $this->request->post['postnl_briefpost_eu_100'];
		} else {
			$this->data['postnl_briefpost_eu_100'] = $this->config->get('postnl_briefpost_eu_100');
		}

		if (isset($this->request->post['postnl_briefpost_eu_250'])) {
			$this->data['postnl_briefpost_eu_250'] = $this->request->post['postnl_briefpost_eu_250'];
		} else {
			$this->data['postnl_briefpost_eu_250'] = $this->config->get('postnl_briefpost_eu_250');
		}

		if (isset($this->request->post['postnl_briefpost_eu_500'])) {
			$this->data['postnl_briefpost_eu_500'] = $this->request->post['postnl_briefpost_eu_500'];
		} else {
			$this->data['postnl_briefpost_eu_500'] = $this->config->get('postnl_briefpost_eu_500');
		}

		if (isset($this->request->post['postnl_briefpost_eu_2000'])) {
			$this->data['postnl_briefpost_eu_2000'] = $this->request->post['postnl_briefpost_eu_2000'];
		} else {
			$this->data['postnl_briefpost_eu_2000'] = $this->config->get('postnl_briefpost_eu_2000');
		}

		// Briefpost Aangetekend EU
		if (isset($this->request->post['postnl_briefpost_aantekenen_eu_2000'])) {
			$this->data['postnl_briefpost_aantekenen_eu_2000'] = $this->request->post['postnl_briefpost_aantekenen_eu_2000'];
		} else {
			$this->data['postnl_briefpost_aantekenen_eu_2000'] = $this->config->get('postnl_briefpost_aantekenen_eu_2000');
		}

		// Rest of World
		if (isset($this->request->post['postnl_briefpost_row_20'])) {
			$this->data['postnl_briefpost_row_20'] = $this->request->post['postnl_briefpost_row_20'];
		} else {
			$this->data['postnl_briefpost_row_20'] = $this->config->get('postnl_briefpost_row_20');
		}

		if (isset($this->request->post['postnl_briefpost_row_50'])) {
			$this->data['postnl_briefpost_row_50'] = $this->request->post['postnl_briefpost_row_50'];
		} else {
			$this->data['postnl_briefpost_row_50'] = $this->config->get('postnl_briefpost_row_50');
		}

		if (isset($this->request->post['postnl_briefpost_row_100'])) {
			$this->data['postnl_briefpost_row_100'] = $this->request->post['postnl_briefpost_row_100'];
		} else {
			$this->data['postnl_briefpost_row_100'] = $this->config->get('postnl_briefpost_row_100');
		}

		if (isset($this->request->post['postnl_briefpost_row_250'])) {
			$this->data['postnl_briefpost_row_250'] = $this->request->post['postnl_briefpost_row_250'];
		} else {
			$this->data['postnl_briefpost_row_250'] = $this->config->get('postnl_briefpost_row_250');
		}

		if (isset($this->request->post['postnl_briefpost_row_500'])) {
			$this->data['postnl_briefpost_row_500'] = $this->request->post['postnl_briefpost_row_500'];
		} else {
			$this->data['postnl_briefpost_row_500'] = $this->config->get('postnl_briefpost_row_500');
		}

		if (isset($this->request->post['postnl_briefpost_row_2000'])) {
			$this->data['postnl_briefpost_row_2000'] = $this->request->post['postnl_briefpost_row_2000'];
		} else {
			$this->data['postnl_briefpost_row_2000'] = $this->config->get('postnl_briefpost_row_2000');
		}

		// aangetekend ROW
		if (isset($this->request->post['postnl_briefpost_aantekenen_row_2000'])) {
			$this->data['postnl_briefpost_aantekenen_row_2000'] = $this->request->post['postnl_briefpost_aantekenen_row_2000'];
		} else {
			$this->data['postnl_briefpost_aantekenen_row_2000'] = $this->config->get('postnl_briefpost_aantekenen_row_2000');
		}

		// Nederland
		if (isset($this->request->post['postnl_nl_10'])) {
			$this->data['postnl_nl_10'] = $this->request->post['postnl_nl_10'];
		} else {
			$this->data['postnl_nl_10'] = $this->config->get('postnl_nl_10');
		}

		if (isset($this->request->post['postnl_nl_30'])) {
			$this->data['postnl_nl_30'] = $this->request->post['postnl_nl_30'];
		} else {
			$this->data['postnl_nl_30'] = $this->config->get('postnl_nl_30');
		}

		if (isset($this->request->post['postnl_nl_aantekenen_10'])) {
			$this->data['postnl_nl_aantekenen_10'] = $this->request->post['postnl_nl_aantekenen_10'];
		} else {
			$this->data['postnl_nl_aantekenen_10'] = $this->config->get('postnl_nl_aantekenen_10');
		}

		if (isset($this->request->post['postnl_nl_aantekenen_30'])) {
			$this->data['postnl_nl_aantekenen_30'] = $this->request->post['postnl_nl_aantekenen_30'];
		} else {
			$this->data['postnl_nl_aantekenen_30'] = $this->config->get('postnl_nl_aantekenen_30');
		}

		if (isset($this->request->post['postnl_nl_verzekerd_10'])) {
			$this->data['postnl_nl_verzekerd_10'] = $this->request->post['postnl_nl_verzekerd_10'];
		} else {
			$this->data['postnl_nl_verzekerd_10'] = $this->config->get('postnl_nl_verzekerd_10');
		}

		if (isset($this->request->post['postnl_nl_verzekerd_30'])) {
			$this->data['postnl_nl_verzekerd_30'] = $this->request->post['postnl_nl_verzekerd_30'];
		} else {
			$this->data['postnl_nl_verzekerd_30'] = $this->config->get('postnl_nl_verzekerd_30');
		}

		if (isset($this->request->post['postnl_nl_spoed_02'])) {
			$this->data['postnl_nl_spoed_02'] = $this->request->post['postnl_nl_spoed_02'];
		} else {
			$this->data['postnl_nl_spoed_02'] = $this->config->get('postnl_nl_spoed_02');
		}

		if (isset($this->request->post['postnl_nl_spoed_05'])) {
			$this->data['postnl_nl_spoed_05'] = $this->request->post['postnl_nl_spoed_05'];
		} else {
			$this->data['postnl_nl_spoed_05'] = $this->config->get('postnl_nl_spoed_05');
		}

		if (isset($this->request->post['postnl_nl_spoed_10'])) {
			$this->data['postnl_nl_spoed_10'] = $this->request->post['postnl_nl_spoed_10'];
		} else {
			$this->data['postnl_nl_spoed_10'] = $this->config->get('postnl_nl_spoed_10');
		}

		if (isset($this->request->post['postnl_nl_rembours_10'])) {
			$this->data['postnl_nl_rembours_10'] = $this->request->post['postnl_nl_rembours_10'];
		} else {
			$this->data['postnl_nl_rembours_10'] = $this->config->get('postnl_nl_rembours_10');
		}

		if (isset($this->request->post['postnl_nl_rebours_30'])) {
			$this->data['postnl_nl_rembours_30'] = $this->request->post['postnl_nl_rembours_30'];
		} else {
			$this->data['postnl_nl_rembours_30'] = $this->config->get('postnl_nl_rembours_30');
		}
		// Eind Nederland

		// Europa I
		if (isset($this->request->post['postnl_eu1_02'])) {
			$this->data['postnl_eu1_02'] = $this->request->post['postnl_eu1_02'];
		} else {
			$this->data['postnl_eu1_02'] = $this->config->get('postnl_eu1_02');
		}

		if (isset($this->request->post['postnl_eu1_05'])) {
			$this->data['postnl_eu1_05'] = $this->request->post['postnl_eu1_05'];
		} else {
			$this->data['postnl_eu1_05'] = $this->config->get('postnl_eu1_05');
		}

		if (isset($this->request->post['postnl_eu1_10'])) {
			$this->data['postnl_eu1_10'] = $this->request->post['postnl_eu1_10'];
		} else {
			$this->data['postnl_eu1_10'] = $this->config->get('postnl_eu1_10');
		}

		if (isset($this->request->post['postnl_eu1_20'])) {
			$this->data['postnl_eu1_20'] = $this->request->post['postnl_eu1_20'];
		} else {
			$this->data['postnl_eu1_20'] = $this->config->get('postnl_eu1_20');
		}

		if (isset($this->request->post['postnl_eu1_30'])) {
			$this->data['postnl_eu1_30'] = $this->request->post['postnl_eu1_30'];
		} else {
			$this->data['postnl_eu1_30'] = $this->config->get('postnl_eu1_30');
		}

		if (isset($this->request->post['postnl_eu1_aantekenen_02'])) {
			$this->data['postnl_eu1_aantekenen_02'] = $this->request->post['postnl_eu1_aantekenen_02'];
		} else {
			$this->data['postnl_eu1_aantekenen_02'] = $this->config->get('postnl_eu1_aantekenen_02');
		}

		if (isset($this->request->post['postnl_eu1_aantekenen_05'])) {
			$this->data['postnl_eu1_aantekenen_05'] = $this->request->post['postnl_eu1_aantekenen_05'];
		} else {
			$this->data['postnl_eu1_aantekenen_05'] = $this->config->get('postnl_eu1_aantekenen_05');
		}

		if (isset($this->request->post['postnl_eu1_aantekenen_10'])) {
			$this->data['postnl_eu1_aantekenen_10'] = $this->request->post['postnl_eu1_aantekenen_10'];
		} else {
			$this->data['postnl_eu1_aantekenen_10'] = $this->config->get('postnl_eu1_aantekenen_10');
		}

		if (isset($this->request->post['postnl_eu1_aantekenen_20'])) {
			$this->data['postnl_eu1_aantekenen_20'] = $this->request->post['postnl_eu1_aantekenen_20'];
		} else {
			$this->data['postnl_eu1_aantekenen_20'] = $this->config->get('postnl_eu1_aantekenen_20');
		}

		if (isset($this->request->post['postnl_eu1_aantekenen_30'])) {
			$this->data['postnl_eu1_aantekenen_30'] = $this->request->post['postnl_eu1_aantekenen_30'];
		} else {
			$this->data['postnl_eu1_aantekenen_30'] = $this->config->get('postnl_eu1_aantekenen_30');
		}

		if (isset($this->request->post['postnl_eu1_verzekerd_02'])) {
			$this->data['postnl_eu1_verzekerd_02'] = $this->request->post['postnl_eu1_verzekerd_02'];
		} else {
			$this->data['postnl_eu1_verzekerd_02'] = $this->config->get('postnl_eu1_verzekerd_02');
		}

		if (isset($this->request->post['postnl_eu1_verzekerd_05'])) {
			$this->data['postnl_eu1_verzekerd_05'] = $this->request->post['postnl_eu1_verzekerd_05'];
		} else {
			$this->data['postnl_eu1_verzekerd_05'] = $this->config->get('postnl_eu1_verzekerd_05');
		}

		if (isset($this->request->post['postnl_eu1_verzekerd_10'])) {
			$this->data['postnl_eu1_verzekerd_10'] = $this->request->post['postnl_eu1_verzekerd_10'];
		} else {
			$this->data['postnl_eu1_verzekerd_10'] = $this->config->get('postnl_eu1_verzekerd_10');
		}

		if (isset($this->request->post['postnl_eu1_verzekerd_20'])) {
			$this->data['postnl_eu1_verzekerd_20'] = $this->request->post['postnl_eu1_verzekerd_20'];
		} else {
			$this->data['postnl_eu1_verzekerd_20'] = $this->config->get('postnl_eu1_verzekerd_20');
		}

		if (isset($this->request->post['postnl_eu1_verzekerd_30'])) {
			$this->data['postnl_eu1_verzekerd_30'] = $this->request->post['postnl_eu1_verzekerd_30'];
		} else {
			$this->data['postnl_eu1_verzekerd_30'] = $this->config->get('postnl_eu1_verzekerd_30');
		}

		if (isset($this->request->post['postnl_eu1_spoed_02'])) {
			$this->data['postnl_eu1_spoed_02'] = $this->request->post['postnl_eu1_spoed_02'];
		} else {
			$this->data['postnl_eu1_spoed_02'] = $this->config->get('postnl_eu1_spoed_02');
		}

		if (isset($this->request->post['postnl_eu1_spoed_05'])) {
			$this->data['postnl_eu1_spoed_05'] = $this->request->post['postnl_eu1_spoed_05'];
		} else {
			$this->data['postnl_eu1_spoed_05'] = $this->config->get('postnl_eu1_spoed_05');
		}

		if (isset($this->request->post['postnl_eu1_spoed_10'])) {
			$this->data['postnl_eu1_spoed_10'] = $this->request->post['postnl_eu1_spoed_10'];
		} else {
			$this->data['postnl_eu1_spoed_10'] = $this->config->get('postnl_eu1_spoed_10');
		}
		// Eind Europa I

		// Europa II
		if (isset($this->request->post['postnl_eu2_02'])) {
			$this->data['postnl_eu2_02'] = $this->request->post['postnl_eu2_02'];
		} else {
			$this->data['postnl_eu2_02'] = $this->config->get('postnl_eu2_02');
		}

		if (isset($this->request->post['postnl_eu2_05'])) {
			$this->data['postnl_eu2_05'] = $this->request->post['postnl_eu2_05'];
		} else {
			$this->data['postnl_eu2_05'] = $this->config->get('postnl_eu2_05');
		}

		if (isset($this->request->post['postnl_eu2_10'])) {
			$this->data['postnl_eu2_10'] = $this->request->post['postnl_eu2_10'];
		} else {
			$this->data['postnl_eu2_10'] = $this->config->get('postnl_eu2_10');
		}

		if (isset($this->request->post['postnl_eu2_20'])) {
			$this->data['postnl_eu2_20'] = $this->request->post['postnl_eu2_20'];
		} else {
			$this->data['postnl_eu2_20'] = $this->config->get('postnl_eu2_20');
		}

		if (isset($this->request->post['postnl_eu2_30'])) {
			$this->data['postnl_eu2_30'] = $this->request->post['postnl_eu2_30'];
		} else {
			$this->data['postnl_eu2_30'] = $this->config->get('postnl_eu2_30');
		}

		if (isset($this->request->post['postnl_eu2_aantekenen_02'])) {
			$this->data['postnl_eu2_aantekenen_02'] = $this->request->post['postnl_eu2_aantekenen_02'];
		} else {
			$this->data['postnl_eu2_aantekenen_02'] = $this->config->get('postnl_eu2_aantekenen_02');
		}

		if (isset($this->request->post['postnl_eu2_aantekenen_05'])) {
			$this->data['postnl_eu2_aantekenen_05'] = $this->request->post['postnl_eu2_aantekenen_05'];
		} else {
			$this->data['postnl_eu2_aantekenen_05'] = $this->config->get('postnl_eu2_aantekenen_05');
		}

		if (isset($this->request->post['postnl_eu2_aantekenen_10'])) {
			$this->data['postnl_eu2_aantekenen_10'] = $this->request->post['postnl_eu2_aantekenen_10'];
		} else {
			$this->data['postnl_eu2_aantekenen_10'] = $this->config->get('postnl_eu2_aantekenen_10');
		}

		if (isset($this->request->post['postnl_eu2_aantekenen_20'])) {
			$this->data['postnl_eu2_aantekenen_20'] = $this->request->post['postnl_eu2_aantekenen_20'];
		} else {
			$this->data['postnl_eu2_aantekenen_20'] = $this->config->get('postnl_eu2_aantekenen_20');
		}

		if (isset($this->request->post['postnl_eu2_aantekenen_30'])) {
			$this->data['postnl_eu2_aantekenen_30'] = $this->request->post['postnl_eu2_aantekenen_30'];
		} else {
			$this->data['postnl_eu2_aantekenen_30'] = $this->config->get('postnl_eu2_aantekenen_30');
		}

		if (isset($this->request->post['postnl_eu2_verzekerd_02'])) {
			$this->data['postnl_eu2_verzekerd_02'] = $this->request->post['postnl_eu2_verzekerd_02'];
		} else {
			$this->data['postnl_eu2_verzekerd_02'] = $this->config->get('postnl_eu2_verzekerd_02');
		}

		if (isset($this->request->post['postnl_eu2_verzekerd_05'])) {
			$this->data['postnl_eu2_verzekerd_05'] = $this->request->post['postnl_eu2_verzekerd_05'];
		} else {
			$this->data['postnl_eu2_verzekerd_05'] = $this->config->get('postnl_eu2_verzekerd_05');
		}

		if (isset($this->request->post['postnl_eu2_verzekerd_10'])) {
			$this->data['postnl_eu2_verzekerd_10'] = $this->request->post['postnl_eu2_verzekerd_10'];
		} else {
			$this->data['postnl_eu2_verzekerd_10'] = $this->config->get('postnl_eu2_verzekerd_10');
		}

		if (isset($this->request->post['postnl_eu2_verzekerd_20'])) {
			$this->data['postnl_eu2_verzekerd_20'] = $this->request->post['postnl_eu2_verzekerd_20'];
		} else {
			$this->data['postnl_eu2_verzekerd_20'] = $this->config->get('postnl_eu2_verzekerd_20');
		}

		if (isset($this->request->post['postnl_eu2_verzekerd_30'])) {
			$this->data['postnl_eu2_verzekerd_30'] = $this->request->post['postnl_eu2_verzekerd_30'];
		} else {
			$this->data['postnl_eu2_verzekerd_30'] = $this->config->get('postnl_eu2_verzekerd_30');
		}

		if (isset($this->request->post['postnl_eu2_spoed_02'])) {
			$this->data['postnl_eu2_spoed_02'] = $this->request->post['postnl_eu2_spoed_02'];
		} else {
			$this->data['postnl_eu2_spoed_02'] = $this->config->get('postnl_eu2_spoed_02');
		}

		if (isset($this->request->post['postnl_eu2_spoed_05'])) {
			$this->data['postnl_eu2_spoed_05'] = $this->request->post['postnl_eu2_spoed_05'];
		} else {
			$this->data['postnl_eu2_spoed_05'] = $this->config->get('postnl_eu2_spoed_05');
		}

		if (isset($this->request->post['postnl_eu2_spoed_10'])) {
			$this->data['postnl_eu2_spoed_10'] = $this->request->post['postnl_eu2_spoed_10'];
		} else {
			$this->data['postnl_eu2_spoed_10'] = $this->config->get('postnl_eu2_spoed_10');
		}
		// Eind Europa II

		// Europa III
		if (isset($this->request->post['postnl_eu3_02'])) {
			$this->data['postnl_eu3_02'] = $this->request->post['postnl_eu3_02'];
		} else {
			$this->data['postnl_eu3_02'] = $this->config->get('postnl_eu3_02');
		}

		if (isset($this->request->post['postnl_eu3_05'])) {
			$this->data['postnl_eu3_05'] = $this->request->post['postnl_eu3_05'];
		} else {
			$this->data['postnl_eu3_05'] = $this->config->get('postnl_eu3_05');
		}

		if (isset($this->request->post['postnl_eu3_10'])) {
			$this->data['postnl_eu3_10'] = $this->request->post['postnl_eu3_10'];
		} else {
			$this->data['postnl_eu3_10'] = $this->config->get('postnl_eu3_10');
		}

		if (isset($this->request->post['postnl_eu3_20'])) {
			$this->data['postnl_eu3_20'] = $this->request->post['postnl_eu3_20'];
		} else {
			$this->data['postnl_eu3_20'] = $this->config->get('postnl_eu3_20');
		}

		if (isset($this->request->post['postnl_eu3_aantekenen_02'])) {
			$this->data['postnl_eu3_aantekenen_02'] = $this->request->post['postnl_eu3_aantekenen_02'];
		} else {
			$this->data['postnl_eu3_aantekenen_02'] = $this->config->get('postnl_eu3_aantekenen_02');
		}

		if (isset($this->request->post['postnl_eu3_aantekenen_05'])) {
			$this->data['postnl_eu3_aantekenen_05'] = $this->request->post['postnl_eu3_aantekenen_05'];
		} else {
			$this->data['postnl_eu3_aantekenen_05'] = $this->config->get('postnl_eu3_aantekenen_05');
		}

		if (isset($this->request->post['postnl_eu3_aantekenen_10'])) {
			$this->data['postnl_eu3_aantekenen_10'] = $this->request->post['postnl_eu3_aantekenen_10'];
		} else {
			$this->data['postnl_eu3_aantekenen_10'] = $this->config->get('postnl_eu3_aantekenen_10');
		}

		if (isset($this->request->post['postnl_eu3_aantekenen_20'])) {
			$this->data['postnl_eu3_aantekenen_20'] = $this->request->post['postnl_eu3_aantekenen_20'];
		} else {
			$this->data['postnl_eu3_aantekenen_20'] = $this->config->get('postnl_eu3_aantekenen_20');
		}

		if (isset($this->request->post['postnl_eu3_verzekerd_02'])) {
			$this->data['postnl_eu3_verzekerd_02'] = $this->request->post['postnl_eu3_verzekerd_02'];
		} else {
			$this->data['postnl_eu3_verzekerd_02'] = $this->config->get('postnl_eu3_verzekerd_02');
		}

		if (isset($this->request->post['postnl_eu3_verzekerd_05'])) {
			$this->data['postnl_eu3_verzekerd_05'] = $this->request->post['postnl_eu3_verzekerd_05'];
		} else {
			$this->data['postnl_eu3_verzekerd_05'] = $this->config->get('postnl_eu3_verzekerd_05');
		}

		if (isset($this->request->post['postnl_eu3_verzekerd_10'])) {
			$this->data['postnl_eu3_verzekerd_10'] = $this->request->post['postnl_eu3_verzekerd_10'];
		} else {
			$this->data['postnl_eu3_verzekerd_10'] = $this->config->get('postnl_eu3_verzekerd_10');
		}

		if (isset($this->request->post['postnl_eu3_verzekerd_20'])) {
			$this->data['postnl_eu3_verzekerd_20'] = $this->request->post['postnl_eu3_verzekerd_20'];
		} else {
			$this->data['postnl_eu3_verzekerd_20'] = $this->config->get('postnl_eu3_verzekerd_20');
		}
		// Eind Europa III

		// Rest van de Wereld
		if (isset($this->request->post['postnl_wereld_02'])) {
			$this->data['postnl_wereld_02'] = $this->request->post['postnl_wereld_02'];
		} else {
			$this->data['postnl_wereld_02'] = $this->config->get('postnl_wereld_02');
		}

		if (isset($this->request->post['postnl_wereld_05'])) {
			$this->data['postnl_wereld_05'] = $this->request->post['postnl_wereld_05'];
		} else {
			$this->data['postnl_wereld_05'] = $this->config->get('postnl_wereld_05');
		}

		if (isset($this->request->post['postnl_wereld_10'])) {
			$this->data['postnl_wereld_10'] = $this->request->post['postnl_wereld_10'];
		} else {
			$this->data['postnl_wereld_10'] = $this->config->get('postnl_wereld_10');
		}

		if (isset($this->request->post['postnl_wereld_20'])) {
			$this->data['postnl_wereld_20'] = $this->request->post['postnl_wereld_20'];
		} else {
			$this->data['postnl_wereld_20'] = $this->config->get('postnl_wereld_20');
		}

		if (isset($this->request->post['postnl_wereld_aantekenen_02'])) {
			$this->data['postnl_wereld_aantekenen_02'] = $this->request->post['postnl_wereld_aantekenen_02'];
		} else {
			$this->data['postnl_wereld_aantekenen_02'] = $this->config->get('postnl_wereld_aantekenen_02');
		}

		if (isset($this->request->post['postnl_wereld_aantekenen_05'])) {
			$this->data['postnl_wereld_aantekenen_05'] = $this->request->post['postnl_wereld_aantekenen_05'];
		} else {
			$this->data['postnl_wereld_aantekenen_05'] = $this->config->get('postnl_wereld_aantekenen_05');
		}

		if (isset($this->request->post['postnl_wereld_aantekenen_10'])) {
			$this->data['postnl_wereld_aantekenen_10'] = $this->request->post['postnl_wereld_aantekenen_10'];
		} else {
			$this->data['postnl_wereld_aantekenen_10'] = $this->config->get('postnl_wereld_aantekenen_10');
		}

		if (isset($this->request->post['postnl_wereld_aantekenen_20'])) {
			$this->data['postnl_wereld_aantekenen_20'] = $this->request->post['postnl_wereld_aantekenen_20'];
		} else {
			$this->data['postnl_wereld_aantekenen_20'] = $this->config->get('postnl_wereld_aantekenen_20');
		}

		if (isset($this->request->post['postnl_wereld_verzekerd_02'])) {
			$this->data['postnl_wereld_verzekerd_02'] = $this->request->post['postnl_wereld_verzekerd_02'];
		} else {
			$this->data['postnl_wereld_verzekerd_02'] = $this->config->get('postnl_wereld_verzekerd_02');
		}

		if (isset($this->request->post['postnl_wereld_verzekerd_05'])) {
			$this->data['postnl_wereld_verzekerd_05'] = $this->request->post['postnl_wereld_verzekerd_05'];
		} else {
			$this->data['postnl_wereld_verzekerd_05'] = $this->config->get('postnl_wereld_verzekerd_05');
		}

		if (isset($this->request->post['postnl_wereld_verzekerd_10'])) {
			$this->data['postnl_wereld_verzekerd_10'] = $this->request->post['postnl_wereld_verzekerd_10'];
		} else {
			$this->data['postnl_wereld_verzekerd_10'] = $this->config->get('postnl_wereld_verzekerd_10');
		}

		if (isset($this->request->post['postnl_wereld_verzekerd_20'])) {
			$this->data['postnl_wereld_verzekerd_20'] = $this->request->post['postnl_wereld_verzekerd_20'];
		} else {
			$this->data['postnl_wereld_verzekerd_20'] = $this->config->get('postnl_wereld_verzekerd_20');
		}
		// Eind Rest van de Wereld

		// Settings
		if (isset($this->request->post['postnl_display_weight'])) {
			$this->data['postnl_display_weight'] = $this->request->post['postnl_display_weight'];
		} else {
			$this->data['postnl_display_weight'] = $this->config->get('postnl_display_weight');
		}

		if (isset($this->request->post['postnl_display_insurance'])) {
			$this->data['postnl_display_insurance'] = $this->request->post['postnl_display_insurance'];
		} else {
			$this->data['postnl_display_insurance'] = $this->config->get('postnl_display_insurance');
		}

		if (isset($this->request->post['postnl_display_time'])) {
			$this->data['postnl_display_time'] = $this->request->post['postnl_display_time'];
		} else {
			$this->data['postnl_display_time'] = $this->config->get('postnl_display_time');
		}

		if (isset($this->request->post['postnl_use_freeshipping'])) {
			$this->data['postnl_use_freeshipping'] = $this->request->post['postnl_use_freeshipping'];
		} else {
			$this->data['postnl_use_freeshipping'] = $this->config->get('postnl_use_freeshipping');
		}

		if (isset($this->request->post['postnl_max_briefwaarde'])) {
			$this->data['postnl_max_briefwaarde'] = $this->request->post['postnl_max_briefwaarde'];
		} else {
			$this->data['postnl_max_briefwaarde'] = $this->config->get('postnl_max_briefwaarde');
		}

		if (isset($this->request->post['postnl_max_pakketwaarde'])) {
			$this->data['postnl_max_pakketwaarde'] = $this->request->post['postnl_max_pakketwaarde'];
		} else {
			$this->data['postnl_max_pakketwaarde'] = $this->config->get('postnl_max_pakketwaarde');
		}

		$this->load->model('localisation/weight_class');

		$this->data['weight_classes'] = $this->model_localisation_weight_class->getWeightClasses();

		if (isset($this->request->post['postnl_tax_class_id'])) {
			$this->data['postnl_tax_class_id'] = $this->request->post['postnl_tax_class_id'];
		} else {
			$this->data['postnl_tax_class_id'] = $this->config->get('postnl_tax_class_id');
		}

		if (isset($this->request->post['postnl_geo_zone_id'])) {
			$this->data['postnl_geo_zone_id'] = $this->request->post['postnl_geo_zone_id'];
		} else {
			$this->data['postnl_geo_zone_id'] = $this->config->get('postnl_geo_zone_id');
		}

		if (isset($this->request->post['postnl_status'])) {
			$this->data['postnl_status'] = $this->request->post['postnl_status'];
		} else {
			$this->data['postnl_status'] = $this->config->get('postnl_status');
		}

		if (isset($this->request->post['postnl_sort_order'])) {
			$this->data['postnl_sort_order'] = $this->request->post['postnl_sort_order'];
		} else {
			$this->data['postnl_sort_order'] = $this->config->get('postnl_sort_order');
		}

		// check radio buttons

		// Brief Post
		if (isset($this->request->post['postnl_briefpost_nl_rb01'])) {
			$this->data['postnl_briefpost_nl_rb01'] = $this->request->post['postnl_briefpost_nl_rb01'];
		} else {
			$this->data['postnl_briefpost_nl_rb01'] = $this->config->get('postnl_briefpost_nl_rb01');
		}

		if (isset($this->request->post['postnl_briefpost_nl_rb02'])) {
			$this->data['postnl_briefpost_nl_rb02'] = $this->request->post['postnl_briefpost_nl_rb02'];
		} else {
			$this->data['postnl_briefpost_nl_rb02'] = $this->config->get('postnl_briefpost_nl_rb02');
		}

		if (isset($this->request->post['postnl_briefpost_nl_rb03'])) {
			$this->data['postnl_briefpost_nl_rb03'] = $this->request->post['postnl_briefpost_nl_rb03'];
		} else {
			$this->data['postnl_briefpost_nl_rb03'] = $this->config->get('postnl_briefpost_nl_rb03');
		}

		// Briefpost europa
		if (isset($this->request->post['postnl_briefpost_eu_rb01'])) {
			$this->data['postnl_briefpost_eu_rb01'] = $this->request->post['postnl_briefpost_eu_rb01'];
		} else {
			$this->data['postnl_briefpost_eu_rb01'] = $this->config->get('postnl_briefpost_eu_rb01');
		}

		if (isset($this->request->post['postnl_briefpost_eu_rb02'])) {
			$this->data['postnl_briefpost_eu_rb02'] = $this->request->post['postnl_briefpost_eu_rb02'];
		} else {
			$this->data['postnl_briefpost_eu_rb02'] = $this->config->get('postnl_briefpost_eu_rb02');
		}
		// Briefpost Rest of world
		if (isset($this->request->post['postnl_briefpost_row_rb01'])) {
			$this->data['postnl_briefpost_row_rb01'] = $this->request->post['postnl_briefpost_row_rb01'];
		} else {
			$this->data['postnl_briefpost_row_rb01'] = $this->config->get('postnl_briefpost_row_rb01');
		}

		if (isset($this->request->post['postnl_briefpost_row_rb02'])) {
			$this->data['postnl_briefpost_row_rb02'] = $this->request->post['postnl_briefpost_row_rb02'];
		} else {
			$this->data['postnl_briefpost_row_rb02'] = $this->config->get('postnl_briefpost_row_rb02');
		}


		// Nederland
		if (isset($this->request->post['postnl_nl_rb01'])) {
			$this->data['postnl_nl_rb01'] = $this->request->post['postnl_nl_rb01'];
		} else {
			$this->data['postnl_nl_rb01'] = $this->config->get('postnl_nl_rb01');
		}

		if (isset($this->request->post['postnl_nl_rb02'])) {
			$this->data['postnl_nl_rb02'] = $this->request->post['postnl_nl_rb02'];
		} else {
			$this->data['postnl_nl_rb02'] = $this->config->get('postnl_nl_rb02');
		}

		if (isset($this->request->post['postnl_nl_rb03'])) {
			$this->data['postnl_nl_rb03'] = $this->request->post['postnl_nl_rb03'];
		} else {
			$this->data['postnl_nl_rb03'] = $this->config->get('postnl_nl_rb03');
		}

		if (isset($this->request->post['postnl_nl_rb04'])) {
			$this->data['postnl_nl_rb04'] = $this->request->post['postnl_nl_rb04'];
		} else {
			$this->data['postnl_nl_rb04'] = $this->config->get('postnl_nl_rb04');
		}

		if (isset($this->request->post['postnl_nl_rb05'])) {
			$this->data['postnl_nl_rb05'] = $this->request->post['postnl_nl_rb05'];
		} else {
			$this->data['postnl_nl_rb05'] = $this->config->get('postnl_nl_rb05');
		}
		// Eind Nederland

		// Europa I
		if (isset($this->request->post['postnl_eu1_rb01'])) {
			$this->data['postnl_eu1_rb01'] = $this->request->post['postnl_eu1_rb01'];
		} else {
			$this->data['postnl_eu1_rb01'] = $this->config->get('postnl_eu1_rb01');
		}

		if (isset($this->request->post['postnl_eu1_rb02'])) {
			$this->data['postnl_eu1_rb02'] = $this->request->post['postnl_eu1_rb02'];
		} else {
			$this->data['postnl_eu1_rb02'] = $this->config->get('postnl_eu1_rb02');
		}

		if (isset($this->request->post['postnl_eu1_rb03'])) {
			$this->data['postnl_eu1_rb03'] = $this->request->post['postnl_eu1_rb03'];
		} else {
			$this->data['postnl_eu1_rb03'] = $this->config->get('postnl_eu1_rb03');
		}

		if (isset($this->request->post['postnl_eu1_rb05'])) {
			$this->data['postnl_eu1_rb05'] = $this->request->post['postnl_eu1_rb05'];
		} else {
			$this->data['postnl_eu1_rb05'] = $this->config->get('postnl_eu1_rb05');
		}
		// Eind Europa I

		// Europa II
		if (isset($this->request->post['postnl_eu2_rb01'])) {
			$this->data['postnl_eu2_rb01'] = $this->request->post['postnl_eu2_rb01'];
		} else {
			$this->data['postnl_eu2_rb01'] = $this->config->get('postnl_eu2_rb01');
		}

		if (isset($this->request->post['postnl_eu2_rb02'])) {
			$this->data['postnl_eu2_rb02'] = $this->request->post['postnl_eu2_rb02'];
		} else {
			$this->data['postnl_eu2_rb02'] = $this->config->get('postnl_eu2_rb02');
		}

		if (isset($this->request->post['postnl_eu2_rb03'])) {
			$this->data['postnl_eu2_rb03'] = $this->request->post['postnl_eu2_rb03'];
		} else {
			$this->data['postnl_eu2_rb03'] = $this->config->get('postnl_eu2_rb03');
		}

		if (isset($this->request->post['postnl_eu2_rb05'])) {
			$this->data['postnl_eu2_rb05'] = $this->request->post['postnl_eu2_rb05'];
		} else {
			$this->data['postnl_eu2_rb05'] = $this->config->get('postnl_eu2_rb05');
		}
		// Eind Europa II

		// Europa III
		if (isset($this->request->post['postnl_eu3_rb01'])) {
			$this->data['postnl_eu3_rb01'] = $this->request->post['postnl_eu3_rb01'];
		} else {
			$this->data['postnl_eu3_rb01'] = $this->config->get('postnl_eu3_rb01');
		}

		if (isset($this->request->post['postnl_eu3_rb02'])) {
			$this->data['postnl_eu3_rb02'] = $this->request->post['postnl_eu3_rb02'];
		} else {
			$this->data['postnl_eu3_rb02'] = $this->config->get('postnl_eu3_rb02');
		}

		if (isset($this->request->post['postnl_eu3_rb03'])) {
			$this->data['postnl_eu3_rb03'] = $this->request->post['postnl_eu3_rb03'];
		} else {
			$this->data['postnl_eu3_rb03'] = $this->config->get('postnl_eu3_rb03');
		}
		// Eind Europa III

		// Rest van de Wereld
		if (isset($this->request->post['postnl_wereld_rb01'])) {
			$this->data['postnl_wereld_rb01'] = $this->request->post['postnl_wereld_rb01'];
		} else {
			$this->data['postnl_wereld_rb01'] = $this->config->get('postnl_wereld_rb01');
		}

		if (isset($this->request->post['postnl_wereld_rb02'])) {
			$this->data['postnl_wereld_rb02'] = $this->request->post['postnl_wereld_rb02'];
		} else {
			$this->data['postnl_wereld_rb02'] = $this->config->get('postnl_wereld_rb02');
		}

		if (isset($this->request->post['postnl_wereld_rb03'])) {
			$this->data['postnl_wereld_rb03'] = $this->request->post['postnl_wereld_rb03'];
		} else {
			$this->data['postnl_wereld_rb03'] = $this->config->get('postnl_wereld_rb03');
		}
		// Eind Rest van de Wereld

		// Discounts for letterbox mail
		// Netherlands
		if (isset($this->request->post['postnl_discount_nl_std'])) {
			$this->data['postnl_discount_nl_std'] = $this->request->post['postnl_discount_nl_std'];
		} else {
			$this->data['postnl_discount_nl_std'] = $this->config->get('postnl_discount_nl_std');
		}

		if (isset($this->request->post['postnl_discount_nl_aan'])) {
			$this->data['postnl_discount_nl_aan'] = $this->request->post['postnl_discount_nl_aan'];
		} else {
			$this->data['postnl_discount_nl_aan'] = $this->config->get('postnl_discount_nl_aan');
		}

		if (isset($this->request->post['postnl_discount_nl_rem'])) {
			$this->data['postnl_discount_nl_rem'] = $this->request->post['postnl_discount_nl_rem'];
		} else {
			$this->data['postnl_discount_nl_rem'] = $this->config->get('postnl_discount_nl_rem');
		}

		// end Netherlands

		// Discount Lettermail Europe and ROW

		if (isset($this->request->post['postnl_discount_eu1_std'])) {
			$this->data['postnl_discount_eu1_std'] = $this->request->post['postnl_discount_eu1_std'];
		} else {
			$this->data['postnl_discount_eu1_std'] = $this->config->get('postnl_discount_eu1_std');
		}

		if (isset($this->request->post['postnl_discount_eu1_aan'])) {
			$this->data['postnl_discount_eu1_aan'] = $this->request->post['postnl_discount_eu1_aan'];
		} else {
			$this->data['postnl_discount_eu1_aan'] = $this->config->get('postnl_discount_eu1_aan');
		}

		if (isset($this->request->post['postnl_discount_world_std'])) {
			$this->data['postnl_discount_world_std'] = $this->request->post['postnl_discount_world_std'];
		} else {
			$this->data['postnl_discount_world_std'] = $this->config->get('postnl_discount_world_std');
		}

		if (isset($this->request->post['postnl_discount_world_aan'])) {
			$this->data['postnl_discount_world_aan'] = $this->request->post['postnl_discount_world_aan'];
		} else {
			$this->data['postnl_discount_world_aan'] = $this->config->get('postnl_discount_world_aan');
		}

		 // end discount letter mail

		// Discount for Parcels
		// Netherlands

		if (isset($this->request->post['postnl_discount_nl_parcel_std'])) {
			$this->data['postnl_discount_nl_parcel_std'] = $this->request->post['postnl_discount_nl_parcel_std'];
		} else {
			$this->data['postnl_discount_nl_parcel_std'] = $this->config->get('postnl_discount_nl_parcel_std');
		}

		if (isset($this->request->post['postnl_discount_nl_parcel_aan'])) {
			$this->data['postnl_discount_nl_parcel_aan'] = $this->request->post['postnl_discount_nl_parcel_aan'];
		} else {
			$this->data['postnl_discount_nl_parcel_aan'] = $this->config->get('postnl_discount_nl_parcel_aan');
		}

		if (isset($this->request->post['postnl_discount_nl_parcel_ver'])) {
			$this->data['postnl_discount_nl_parcel_ver'] = $this->request->post['postnl_discount_nl_parcel_ver'];
		} else {
			$this->data['postnl_discount_nl_parcel_ver'] = $this->config->get('postnl_discount_nl_parcel_ver');
		}

		if (isset($this->request->post['postnl_discount_nl_parcel_rem'])) {
			$this->data['postnl_discount_nl_parcel_rem'] = $this->request->post['postnl_discount_nl_parcel_rem'];
		} else {
			$this->data['postnl_discount_nl_parcel_rem'] = $this->config->get('postnl_discount_nl_parcel_rem');
		}

		if (isset($this->request->post['postnl_discount_nl_parcel_spoed'])) {
			$this->data['postnl_discount_nl_parcel_spoed'] = $this->request->post['postnl_discount_nl_parcel_spoed'];
		} else {
			$this->data['postnl_discount_nl_parcel_spoed'] = $this->config->get('postnl_discount_nl_parcel_spoed');
		}

		// end Netherlands
		// Europa I
		if (isset($this->request->post['postnl_discount_eu1_parcel_std'])) {
			$this->data['postnl_discount_eu1_parcel_std'] = $this->request->post['postnl_discount_eu1_parcel_std'];
		} else {
			$this->data['postnl_discount_eu1_parcel_std'] = $this->config->get('postnl_discount_eu1_parcel_std');
		}

		if (isset($this->request->post['postnl_discount_eu1_parcel_ver'])) {
			$this->data['postnl_discount_eu1_parcel_ver'] = $this->request->post['postnl_discount_eu1_parcel_ver'];
		} else {
			$this->data['postnl_discount_eu1_parcel_ver'] = $this->config->get('postnl_discount_eu1_parcel_ver');
		}

		if (isset($this->request->post['postnl_discount_eu1_parcel_aan'])) {
			$this->data['postnl_discount_eu1_parcel_aan'] = $this->request->post['postnl_discount_eu1_parcel_aan'];
		} else {
			$this->data['postnl_discount_eu1_parcel_aan'] = $this->config->get('postnl_discount_eu1_parcel_aan');
		}

		if (isset($this->request->post['postnl_discount_eu1_parcel_spoed'])) {
			$this->data['postnl_discount_eu1_parcel_spoed'] = $this->request->post['postnl_discount_eu1_parcel_spoed'];
		} else {
			$this->data['postnl_discount_eu1_parcel_spoed'] = $this->config->get('postnl_discount_eu1_parcel_spoed');
		}
		// end Europa I

		// Europa II
		if (isset($this->request->post['postnl_discount_eu2_parcel_std'])) {
			$this->data['postnl_discount_eu2_parcel_std'] = $this->request->post['postnl_discount_eu2_parcel_std'];
		} else {
			$this->data['postnl_discount_eu2_parcel_std'] = $this->config->get('postnl_discount_eu2_parcel_std');
		}

		if (isset($this->request->post['postnl_discount_eu2_parcel_ver'])) {
			$this->data['postnl_discount_eu2_parcel_ver'] = $this->request->post['postnl_discount_eu2_parcel_ver'];
		} else {
			$this->data['postnl_discount_eu2_parcel_ver'] = $this->config->get('postnl_discount_eu2_parcel_ver');
		}

		if (isset($this->request->post['postnl_discount_eu2_parcel_aan'])) {
			$this->data['postnl_discount_eu2_parcel_aan'] = $this->request->post['postnl_discount_eu2_parcel_aan'];
		} else {
			$this->data['postnl_discount_eu2_parcel_aan'] = $this->config->get('postnl_discount_eu2_parcel_aan');
		}

		if (isset($this->request->post['postnl_discount_eu2_parcel_spoed'])) {
			$this->data['postnl_discount_eu2_parcel_spoed'] = $this->request->post['postnl_discount_eu2_parcel_spoed'];
		} else {
			$this->data['postnl_discount_eu2_parcel_spoed'] = $this->config->get('postnl_discount_eu2_parcel_spoed');
		}
		// end Europa II

		// Europa III
		if (isset($this->request->post['postnl_discount_eu3_parcel_std'])) {
			$this->data['postnl_discount_eu3_parcel_std'] = $this->request->post['postnl_discount_eu3_parcel_std'];
		} else {
			$this->data['postnl_discount_eu3_parcel_std'] = $this->config->get('postnl_discount_eu3_parcel_std');
		}

		if (isset($this->request->post['postnl_discount_eu3_parcel_ver'])) {
			$this->data['postnl_discount_eu3_parcel_ver'] = $this->request->post['postnl_discount_eu3_parcel_ver'];
		} else {
			$this->data['postnl_discount_eu3_parcel_ver'] = $this->config->get('postnl_discount_eu3_parcel_ver');
		}

		if (isset($this->request->post['postnl_discount_eu3_parcel_aan'])) {
			$this->data['postnl_discount_eu3_parcel_aan'] = $this->request->post['postnl_discount_eu3_parcel_aan'];
		} else {
			$this->data['postnl_discount_eu3_parcel_aan'] = $this->config->get('postnl_discount_eu3_parcel_aan');
		}
		// end Europa II

		// Rest of the World
		if (isset($this->request->post['postnl_discount_world_parcel_std'])) {
			$this->data['postnl_discount_world_parcel_std'] = $this->request->post['postnl_discount_world_parcel_std'];
		} else {
			$this->data['postnl_discount_world_parcel_std'] = $this->config->get('postnl_discount_world_parcel_std');
		}

		if (isset($this->request->post['postnl_discount_world_parcel_ver'])) {
			$this->data['postnl_discount_world_parcel_ver'] = $this->request->post['postnl_discount_world_parcel_ver'];
		} else {
			$this->data['postnl_discount_world_parcel_ver'] = $this->config->get('postnl_discount_world_parcel_ver');
		}

		if (isset($this->request->post['postnl_discount_world_parcel_aan'])) {
			$this->data['postnl_discount_world_parcel_aan'] = $this->request->post['postnl_discount_world_parcel_aan'];
		} else {
			$this->data['postnl_discount_world_parcel_aan'] = $this->config->get('postnl_discount_world_parcel_aan');
		}
		// end Rest of the World

		// End of Discounts

		// beging Shipping boxes
		if (isset($this->request->post['postnl_letterbox'])) {
			$this->data['postnl_letterbox'] = $this->request->post['postnl_letterbox'];
		} else {
			$this->data['postnl_letterbox'] = $this->config->get('postnl_letterbox');
		}

		if (isset($this->request->post['postnl_cardbox'])) {
			$this->data['postnl_cardbox'] = $this->request->post['postnl_cardbox'];
		} else {
			$this->data['postnl_cardbox'] = $this->config->get('postnl_cardbox');
		}



		$this->load->model('localisation/geo_zone');

		$geo_zones = $this->model_localisation_geo_zone->getGeoZones();

		foreach ($geo_zones as $geo_zone) {
			if (isset($this->request->post['postnl_' . $geo_zone['geo_zone_id'] . '_rate'])) {
				$this->data['postnl_' . $geo_zone['geo_zone_id'] . '_rate'] = $this->request->post['postnl_' . $geo_zone['geo_zone_id'] . '_rate'];
			} else {
				$this->data['postnl_' . $geo_zone['geo_zone_id'] . '_rate'] = $this->config->get('postnl_' . $geo_zone['geo_zone_id'] . '_rate');
			}

			if (isset($this->request->post['postnl_' . $geo_zone['geo_zone_id'] . '_status'])) {
				$this->data['postnl_' . $geo_zone['geo_zone_id'] . '_status'] = $this->request->post['postnl_' . $geo_zone['geo_zone_id'] . '_status'];
			} else {
				$this->data['postnl_' . $geo_zone['geo_zone_id'] . '_status'] = $this->config->get('postnl_' . $geo_zone['geo_zone_id'] . '_status');
			}
		}

		$this->data['geo_zones'] = $geo_zones;

		if (isset($this->request->post['postnl_tax_class_id'])) {
			$this->data['postnl_tax_class_id'] = $this->request->post['postnl_tax_class_id'];
		} else {
			$this->data['postnl_tax_class_id'] = $this->config->get('postnl_tax_class_id');
		}

		if (isset($this->request->post['postnl_status'])) {
			$this->data['postnl_status'] = $this->request->post['postnl_status'];
		} else {
			$this->data['postnl_status'] = $this->config->get('postnl_status');
		}

		if (isset($this->request->post['postnl_sort_order'])) {
			$this->data['postnl_sort_order'] = $this->request->post['postnl_sort_order'];
		} else {
			$this->data['postnl_sort_order'] = $this->config->get('postnl_sort_order');
		}

		$this->load->model('localisation/tax_class');

		$this->data['tax_classes'] = $this->model_localisation_tax_class->getTaxClasses();

		$this->template = 'shipping/postnl.tpl';
		$this->children = array(
			'common/header',
			'common/footer',
		);

		$this->response->setOutput($this->render());
	}

	private function validate() {
		if (!$this->user->hasPermission('modify', 'shipping/postnl')) {
			$this->error['warning'] = $this->language->get('error_permission');
		}

		if (!$this->error) {
			return true;
		} else {
			return false;
		}
	}
}
?>