<?php
/*
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.

   ---------------------------------------------------------------------
   Gerrit Bouweriks
   OpenCart 1.5.1.1 / 1.5.1.2 / 1.5.1.3 - Dutch PostNL module 1.5.1.1
   Special thank you goes to
   SuperJuice (Sam), for conversions made to weight en length classes
   Sanne for testing and Norman for the translations
   Petran for letterbox solution
*/

class ModelShippingPOSTNL extends Model {
	function getQuote($address)
	{
		$this->load->language('shipping/postnl');

		if ($this->config->get('postnl_status')) {
			$query = $this->db->query("SELECT * FROM " . DB_PREFIX . "zone_to_geo_zone WHERE geo_zone_id = '" . (int)$this->config->get('postnl_geo_zone_id') . "' AND country_id = '" . (int)$address['country_id'] . "' AND (zone_id = '" . (int)$address['zone_id'] . "' OR zone_id = '0')");

			if (!$this->config->get('postnl_geo_zone_id')) {
							$status = true;
			} elseif ($query->num_rows) {
							$status = true;
			} else {
							$status = false;
			}
		} else {
			$status = false;
		}

		if ($this->config->get('postnl_use_freeshipping')) {
			if ($address['iso_code_2'] === 'NL') {
				if ($this->cart->getSubTotal() > $this->config->get('free_total')) {
					$status = false;
				}
			}
		}

		$verzendkosten = 0;
		$error = FALSE;
		$quote_data = array();

		if ($status) {
			//Query to find id of grams (g) as 1.5.1.1 removed the availability of the named unit
			$unit_query =  $this->db->query("SELECT weight_class_id FROM " . DB_PREFIX . "weight_class_description where LOWER(unit) = 'g'");

			if ($unit_query->num_rows) {$unit_g = $unit_query->row['weight_class_id'];}

			$weight = intval($this->weight->convert($this->cart->getWeight(), $this->config->get('config_weight_class_id'), $unit_g));

//			$weight = floatval($this->weight->convert($this->cart->getWeight(), $this->config->get('config_weight_class'), 'g'));
			if ($weight >= 1000) {
				$show_weight = floatval($this->weight->convert($this->cart->getWeight(), $this->config->get('config_weight_class_id'), $unit_g) / 1000);
				$kg = $this->language->get('text_showweight_kilo');

			}
			if ($weight < 1000) {
				$show_weight = floatval($this->weight->convert($this->cart->getWeight(), $this->config->get('config_weight_class_id'), $unit_g));
				$kg = $this->language->get('text_showweight_gram');

			}

			// subtotaal van het karretje exclusief BTW
			$sub_total = $this->cart->getSubTotal();
			// Maximale waarde voor briefpost
			$max_waarde = intval($this->config->get('postnl_max_briefwaarde'));
			if ($max_waarde == 0 || $max_waarde == '') {
				$max_waarde = 999;
			}
			// Maximale waarde voor onverzekerde pakketpost
			$max_pakketwaarde = intval($this->config->get('postnl_max_pakketwaarde'));
			if ($max_pakketwaarde == 0 || $max_pakketwaarde == '') {
				$max_pakketwaarde = 999;
			}

			$cblenght = '';
			$cbwidth = '';
			$cbheight = '';
			$cbweight = '';

			$cbox = $this->config->get('postnl_cardbox');
			if ($cbox == 0) {
				$cblenght = 250;
				$cbwidth = 250;
				$cbheight = 100;
				$cbweight = 100;
			}
			if ($cbox == 1) {
				$cblenght = 300;
				$cbwidth = 220;
				$cbheight = 220;
				$cbweight = 250;
			}
			if ($cbox == 2) {
				$cblenght = 500;
				$cbwidth = 350;
				$cbheight = 350;
				$cbweight = 500;
			}
			if ($cbox == 3) {
				$cblenght = 800;
				$cbwidth = 800;
				$cbheight = 800;
				$cbweight = 0;
			}

			$blenght = '';
			$bwidth = '';
			$bheight = '';
			$bweight = '';

			$lbox = $this->config->get('postnl_letterbox');
			if ($lbox == 1) {
				$blenght = 299;
				$bwidth = 213;
				$bheight = 27;
				$bweight = 85;
			}
			if ($lbox == 2) {
				$blenght = 378;
				$bwidth = 263;
				$bheight = 30;
				$bweight = 150;
			}
			if ($lbox == 3) {
				$blenght = 335;
				$bwidth = 230;
				$bheight = 20;
				$bweight = 24;
			}
			if ($lbox == 4) {
				$blenght = 265;
				$bwidth = 220;
				$bheight = 20;
				$bweight = 18;
			}
			if ($lbox == 5) {
				$blenght = 265;
				$bwidth = 180;
				$bheight = 20;
				$bweight = 14;
			}
			if ($lbox == 6) {
				$blenght = 380;
				$bwidth = 270;
				$bheight = 32;
				$bweight = 0;
			}


			// vanaf hier kijken naar het totale verzend formaat
			$boxlenght = $blenght; 	// komt straks uit tabel
			$boxwidth = $bwidth;	// komt straks uit tabel
			$boxheight = $bheight;	// komt straks uit tabel
			$boxweight = $bweight;	// komt straks uit tabel
			$cboxweight = $cbweight;
			$max = 0;
			$stuk_lenght = 0;
			$stuk_width = 0;
			$stuk_height = 0;
			$postnl_box = 1;

//aanpassing controle doosbreedte
foreach ($this->cart->getProducts() as $cartitem) {
    $max = max($max, $cartitem['length']);
}
    if ($max < $boxwidth) {$boxlenght = $bwidth; $boxwidth = $blenght;}

			// Query to find out if mm are configured in the database because OpenCart developers thought it wasn't needed in the API (currently no error condition if it doesn't exist)
			$unit_query =  $this->db->query("SELECT length_class_id FROM " . DB_PREFIX . "length_class_description where LOWER(unit) = 'mm'");

			if ($unit_query->num_rows) {$unit_mm = $unit_query->row['length_class_id'];}

			foreach ($this->cart->getProducts() as $cartitem) {
				if($cartitem['length_class_id'] != $unit_mm) {
					if($cartitem['width'] != 0) {
						$cartitem['width'] = $this->length->convert($cartitem['width'], $cartitem['length_class_id'], $unit_mm);
					}

					if($cartitem['height'] != 0) {
						$cartitem['height'] = $this->length->convert($cartitem['height'], $cartitem['length_class_id'], $unit_mm);
					}

					if($cartitem['length'] != 0) {
						$cartitem['length'] = $this->length->convert($cartitem['length'], $cartitem['length_class_id'], $unit_mm);
					}
				}


			if($cartitem['width'] == 0) { $cartitem['width'] = $boxwidth + 1;}
			if($cartitem['height'] == 0) { $cartitem['height'] = $boxheight + 1;}
			if($cartitem['length'] == 0) { $cartitem['length'] = $boxlenght + 1;}

		// Petran


			if($cartitem['length'] <= 0 || $cartitem['width'] <= 0 || $cartitem['height'] <= 0) {$postnl_box = 0;}
			if ($cartitem['length'] < $cartitem['width']) {$temp = $cartitem['length']; $cartitem['length'] = $cartitem['width']; $cartitem['width'] = $temp;}
            if ($cartitem['width'] < $cartitem['height']) {$temp = $cartitem['width']; $cartitem['width'] = $cartitem['height']; $cartitem['height'] = $temp;}
            if ($cartitem['length'] < $cartitem['width']) {$temp = $cartitem['length']; $cartitem['length'] = $cartitem['width']; $cartitem['width'] = $temp;}
            if($cartitem['length'] > $boxlenght || $cartitem['width'] > $boxwidth || $cartitem['height'] > $boxheight) {$postnl_box = 0;}

			$stuk_lenght = intval ($boxlenght /  $cartitem['length']); if ($stuk_lenght <= 1) {$stuk_lenght = 1;}//maximaal aantal in de lengte
			$stuk_height = intval ($boxheight /  $cartitem['height']); if ($stuk_height <= 1) {$stuk_height = 1;}//maximaal aantal in de hoogte
			$stuk_width = ceil ($cartitem['quantity']/($stuk_lenght * $stuk_height)); //aantal rijen in de breedte
			$boxwidth =  $boxwidth - ($cartitem['width'] * $stuk_width); //overblijvende ruimte in de doos
				if ($boxwidth < 0) {$postnl_box = 0;}
		// end Petran
			if ($weight >= 2000 || $sub_total > $max_waarde) {
				$postnl_box = 0;  // doos
			}
		}
		// eind formaat bepaling

		// Brievenpost NL
		if ($postnl_box == 1) {
			$weight = $weight + $boxweight;

			if ($this->config->get('postnl_briefpost_nl_rb01') && $address['iso_code_2'] == 'NL' && $weight < 2000) {
				$cost = 0;

				$title_postnl = $this->language->get('text_title_nl');
				$title = $this->language->get('text_postnl_briefpost_nl');

				$discount_postnl = 0;
				$postnl_discount_nl_std = $this->config->get('postnl_discount_nl_std');

				if ($weight > 0 && $weight <= 20) {
					if (isset($postnl_discount_nl_std)) {
						$verzendkosten = $this->config->get('postnl_briefpost_nl_20');
						$discount_postnl = ($verzendkosten / 100) * $postnl_discount_nl_std;
						$verzendkosten = $verzendkosten - $discount_postnl;
					} else {
						$verzendkosten = $this->config->get('postnl_briefpost_nl_20');
					}
				}

				if ($weight > 20 && $weight <= 50) {
					if (isset($postnl_discount_nl_std)) {
						$verzendkosten = $this->config->get('postnl_briefpost_nl_50');
						$discount_postnl = ($verzendkosten / 100) * $postnl_discount_nl_std;
						$verzendkosten = $verzendkosten - $discount_postnl;
					} else {
						$verzendkosten = $this->config->get('postnl_briefpost_nl_50');
					}
				}

				if ($weight > 50 && $weight <= 100) {
					if (isset($postnl_discount_nl_std)) {
						$verzendkosten = $this->config->get('postnl_briefpost_nl_100');
						$discount_postnl = ($verzendkosten / 100) * $postnl_discount_nl_std;
						$verzendkosten = $verzendkosten - $discount_postnl;
					} else {
						$verzendkosten = $this->config->get('postnl_briefpost_nl_100');
					}
				}

				if ($weight > 100 && $weight <= 250) {
					if (isset($postnl_discount_nl_std)) {
						$verzendkosten = $this->config->get('postnl_briefpost_nl_250');
						$discount_postnl = ($verzendkosten / 100) * $postnl_discount_nl_std;
						$verzendkosten = $verzendkosten - $discount_postnl;
					} else {
						$verzendkosten = $this->config->get('postnl_briefpost_nl_250');
					}
				}

				if ($weight > 250 && $weight <= 500) {
					if (isset($postnl_discount_nl_std)) {
						$verzendkosten = $this->config->get('postnl_briefpost_nl_500');
						$discount_postnl = ($verzendkosten / 100) * $postnl_discount_nl_std;
						$verzendkosten = $verzendkosten - $discount_postnl;
					} else {
						$verzendkosten = $this->config->get('postnl_briefpost_nl_500');
					}
				}

				if ($weight > 500 && $weight < 2000) {
					if (isset($postnl_discount_nl_std)) {
						$verzendkosten = $this->config->get('postnl_briefpost_nl_2000');
						$discount_postnl = ($verzendkosten / 100) * $postnl_discount_nl_std;
						$verzendkosten = $verzendkosten - $discount_postnl;
					} else {
						$verzendkosten = $this->config->get('postnl_briefpost_nl_2000');
					}
				}

				if ($weight <= 0) {
					$error = $this->language->get('error_zero_weight');
				}

				if ($this->config->get('postnl_display_weight')) {
					$show_weight = $show_weight + $boxweight;
					$title .= '<span class="help">' . $this->language->get('text_weight') . ' ' . $show_weight . ' ' . $kg . '</span>';
				}

				if ($this->config->get('postnl_display_time')) {
					$title .= $this->language->get('text_eta_next_day');
				}

				$quote_data['postnl_briefpost_nl'] = array(
					'code' => 'postnl.postnl_briefpost_nl',
					'title' => $title,
					'cost' => $verzendkosten,
					'tax_class_id' => $this->config->get('postnl_tax_class_id'),
					'text' => $this->currency->format($this->tax->calculate($verzendkosten, $this->config->get('postnl_tax_class_id'), $this->config->get('config_tax')))
					);
			}
			// Brievenpost Aantekenen_NL
			if ($this->config->get('postnl_briefpost_nl_rb02') && $address['iso_code_2'] == 'NL' && $weight < 2000) {
				$cost = 0;

				$title_postnl = $this->language->get('text_title_nl');
				$title = $this->language->get('text_postnl_briefpost_aantekenen_nl');

				$discount_postnl = 0;
				$postnl_discount_nl_aan = $this->config->get('postnl_discount_nl_aan');

				if ($weight > 0 && $weight < 2000) {
					if (isset($postnl_discount_nl_aan)) {
						$verzendkosten = $this->config->get('postnl_briefpost_aantekenen_nl_2000');
						$discount_postnl = ($verzendkosten / 100) * $postnl_discount_nl_aan;
						$verzendkosten = $verzendkosten - $discount_postnl;
					} else {
						$verzendkosten = $this->config->get('postnl_briefpost_aantekenen_nl_2000');
					}
				}

				if ($weight <= 0) {
					$error = $this->language->get('error_zero_weight');
				}

				if ($this->config->get('postnl_display_weight')) {
					$show_weight = $show_weight + $boxweight;
					$title .= '<span class="help">' . $this->language->get('text_weight') . ' ' . $show_weight . ' ' . $kg . '</span>';
				}

				if ($this->config->get('postnl_display_time')) {
					$title .= $this->language->get('text_eta_next_day');
				}


				$quote_data['postnl_briefpost_aantekenen_nl'] = array(
					'code' => 'postnl.postnl_briefpost_aantekenen_nl',
					'title' => $title,
					'cost' => $verzendkosten,
					'tax_class_id' => $this->config->get('postnl_tax_class_id'),
					'text' => $this->currency->format($this->tax->calculate($verzendkosten, $this->config->get('postnl_tax_class_id'), $this->config->get('config_tax')))
					);
			}

			// Brievenpost Rembours NL
			if ($this->config->get('postnl_briefpost_nl_rb03') && $address['iso_code_2'] == 'NL' && $weight < 2000) {
				$cost = 0;

				$title_postnl = $this->language->get('text_title_nl');
				$title = $this->language->get('text_postnl_briefpost_rembours_nl');

				$discount_postnl = 0;
				$postnl_discount_nl_rem = $this->config->get('postnl_discount_nl_rem');

				if ($weight > 0 && $weight < 2000) {
					if (isset($postnl_discount_nl_rem)) {
						$verzendkosten = $this->config->get('postnl_briefpost_rembours_nl_2000');
						$discount_postnl = ($verzendkosten / 100) * $postnl_discount_nl_rem;
						$verzendkosten = $verzendkosten - $discount_postnl;
					} else {
						$verzendkosten = $this->config->get('postnl_briefpost_rembours_nl_2000');
					}
				}

				if ($weight <= 0) {
					$error = $this->language->get('error_zero_weight');
				}

				if ($this->config->get('postnl_display_weight')) {
					$show_weight = $show_weight + $boxweight;
					$title .= '<span class="help">' . $this->language->get('text_weight') . ' ' . $show_weight . ' ' . $kg . '</span>';
				}

				if ($this->config->get('postnl_display_time')) {
					$title .= $this->language->get('text_eta_next_day');
				}


				$quote_data['postnl_briefpost_rembours_nl'] = array(
					'code' => 'postnl.postnl_briefpost_rembours_nl',
					'title' => $title,
					'cost' => $verzendkosten,
					'tax_class_id' => $this->config->get('postnl_tax_class_id'),
					'text' => $this->currency->format($this->tax->calculate($verzendkosten, $this->config->get('postnl_tax_class_id'), $this->config->get('config_tax')))
					);
			}

			// brievenpost Europa
			$countries = explode(',', 'BE,DK,DE,FR,IT,LU,MC,AT,ES,GB,SE,BG,EE,FI,HU,IE,LV,LT,PL,PT,RO,SI,SK,CZ,AL,AD,CH,
									   VA,CY,BY,GI,GR,GL,IS,JE,HR,LI,MD,ME,MK,MT,NO,UA,SM,RS,TR,IM,GG,BA,FO');

			if ($this->config->get('postnl_briefpost_eu_rb01') && $weight < 2000 && in_array($address['iso_code_2'], $countries)) {
				$cost = 0;

				$title_postnl = $this->language->get('text_title_nl');
				$title = $this->language->get('text_postnl_briefpost_eu');

				$discount_postnl = 0;
				$postnl_discount_eu1_std = $this->config->get('postnl_discount_eu1_std');

				if ($weight > 0 && $weight <= 20) {
					if (isset($postnl_discount_eu1_std)) {
						$verzendkosten = $this->config->get('postnl_briefpost_eu_20');
						$discount_postnl = ($verzendkosten / 100) * $postnl_discount_eu1_std;
						$verzendkosten = $verzendkosten - $discount_postnl;
					} else {
						$verzendkosten = $this->config->get('postnl_briefpost_eu_20');
					}
				}

				if ($weight > 20 && $weight <= 50) {
					if (isset($postnl_discount_eu1_01)) {
						$verzendkosten = $this->config->get('postnl_briefpost_eu_50');
						$discount_postnl = ($verzendkosten / 100) * $postnl_discount_eu1_01;
						$verzendkosten = $verzendkosten - $discount_postnl;
					} else {
						$verzendkosten = $this->config->get('postnl_briefpost_eu_50');
					}
				}

				if ($weight > 50 && $weight <= 100) {
					if (isset($postnl_discount_eu1_01)) {
						$verzendkosten = $this->config->get('postnl_briefpost_eu_100');
						$discount_postnl = ($verzendkosten / 100) * $postnl_discount_eu1_01;
						$verzendkosten = $verzendkosten - $discount_postnl;
					} else {
						$verzendkosten = $this->config->get('postnl_briefpost_eu_100');
					}
				}

				if ($weight > 100 && $weight <= 250) {
					if (isset($postnl_discount_eu1_std)) {
						$verzendkosten = $this->config->get('postnl_briefpost_eu_250');
						$discount_postnl = ($verzendkosten / 100) * $postnl_discount_eu1_std;
						$verzendkosten = $verzendkosten - $discount_postnl;
					} else {
						$verzendkosten = $this->config->get('postnl_briefpost_eu_250');
					}
				}

				if ($weight > 250 && $weight <= 500) {
					if (isset($postnl_discount_eu1_std)) {
						$verzendkosten = $this->config->get('postnl_briefpost_eu_500');
						$discount_postnl = ($verzendkosten / 100) * $postnl_discount_eu1_std;
						$verzendkosten = $verzendkosten - $discount_postnl;
					} else {
						$verzendkosten = $this->config->get('postnl_briefpost_eu_500');
					}
				}

				if ($weight > 500 && $weight < 2000) {
					if (isset($postnl_discount_eu1_std)) {
						$verzendkosten = $this->config->get('postnl_briefpost_eu_2000');
						$discount_postnl = ($verzendkosten / 100) * $postnl_discount_eu1_std;
						$verzendkosten = $verzendkosten - $discount_postnl;
					} else {
						$verzendkosten = $this->config->get('postnl_briefpost_eu_2000');
					}
				}

				if ($weight <= 0) {
					$error = $this->language->get('error_zero_weight');
				}

				if ($this->config->get('postnl_display_weight')) {
					$show_weight = $show_weight + $boxweight;
					$title .= '<span class="help">' . $this->language->get('text_weight') . ' ' . $show_weight . ' ' . $kg . '</span>';
				}

				if ($this->config->get('postnl_display_time')) {
					$title .= $this->language->get('text_eta_next_day');
				}


				$quote_data['postnl_briefpost_eu'] = array(
					'code' => 'postnl.postnl_briefpost_eu',
					'title' => $title,
					'cost' => $verzendkosten,
					'tax_class_id' => $this->config->get('postnl_tax_class_id'),
					'text' => $this->currency->format($this->tax->calculate($verzendkosten, $this->config->get('postnl_tax_class_id'), $this->config->get('config_tax')))
					);
			}

			// Brievenpost aantekenen Europa
			$countries = explode(',', 'BE,DK,DE,FR,IT,LU,MC,AT,ES,GB,SE,BG,EE,FI,HU,IE,LV,LT,PL,PT,RO,SI,SK,CZ,AL,AD,CH,
						   VA,CY,BY,GI,GR,GL,IS,JE,HR,LI,MD,ME,MK,MT,NO,UA,SM,RS,TR,IM,GG,BA,FO');

			if ($this->config->get('postnl_briefpost_eu_rb02') && $weight < 2000 && in_array($address['iso_code_2'], $countries)) {
				$cost = 0;

				$title_postnl = $this->language->get('text_title_nl');
				$title = $this->language->get('text_postnl_briefpost_aantekenen_eu');

				$discount_postnl = 0;
				$postnl_discount_eu1_aan = $this->config->get('postnl_discount_eu1_aan');

				if ($weight > 0 && $weight < 2000) {
					if (isset($postnl_discount_eu1_aan)) {
						$verzendkosten = $this->config->get('postnl_briefpost_aantekenen_eu_2000');
						$discount_postnl = ($verzendkosten / 100) * $postnl_discount_eu1_aan;
						$verzendkosten = $verzendkosten - $discount_postnl;
					} else {
						$verzendkosten = $this->config->get('postnl_briefpost_aantekenen_eu_2000');
					}
				}

				if ($weight <= 0) {
					$error = $this->language->get('error_zero_weight');
				}

				if ($this->config->get('postnl_display_weight')) {
					$show_weight = $show_weight + $boxweight;
					$title .= '<span class="help">' . $this->language->get('text_weight') . ' ' . $show_weight . ' ' . $kg . '</span>';
				}

				if ($this->config->get('postnl_display_time')) {
					$title .= $this->language->get('text_eta_next_day');
				}


				$quote_data['postnl_briefpost_aantekenen_eu'] = array(
					'code' => 'postnl.postnl_briefpost_aantekenen_eu',
					'title' => $title,
					'cost' => $verzendkosten,
					'tax_class_id' => $this->config->get('postnl_tax_class_id'),
					'text' => $this->currency->format($this->tax->calculate($verzendkosten, $this->config->get('postnl_tax_class_id'), $this->config->get('config_tax')))
					);
			}

			// Brievenpost Rest of World
			$countries = explode(',', 'BE,DK,DE,FR,IT,LU,MC,AT,ES,GB,SE,BG,EE,FI,HU,IE,LV,LT,PL,PT,RO,SI,SK,CZ,AL,AD,CH,
									   VA,CY,BY,GI,GR,GL,IS,JE,HR,LI,MD,ME,MK,MT,NO,UA,SM,RS,TR,IM,GG,BA,FO,NL');

			if ($this->config->get('postnl_briefpost_row_rb01') && $weight < 2000 && !(in_array($address['iso_code_2'], $countries))) {
				$cost = 0;

				$title_postnl = $this->language->get('text_title_nl');
				$title = $this->language->get('text_postnl_briefpost_row');

				$discount_postnl = 0;
				$postnl_discount_world_std = $this->config->get('$postnl_discount_world_std');


				if ($weight > 0 && $weight <= 20) {
					if (isset($postnl_discount_world_std)) {
						$verzendkosten = $this->config->get('postnl_briefpost_row_20');
						$discount_postnl = ($verzendkosten / 100) * $postnl_discount_world_std;
						$verzendkosten = $verzendkosten - $discount_postnl;
					} else {
						$verzendkosten = $this->config->get('postnl_briefpost_row_20');
					}
				}

				if ($weight > 20 && $weight <= 50) {
					if (isset($postnl_discount_world_std)) {
						$verzendkosten = $this->config->get('postnl_briefpost_row_50');
						$discount_postnl = ($verzendkosten / 100) * $postnl_discount_world_std;
						$verzendkosten = $verzendkosten - $discount_postnl;
					} else {
						$verzendkosten = $this->config->get('postnl_briefpost_row_50');
					}
				}

				if ($weight > 50 && $weight <= 100) {
					if (isset($postnl_discount_world_std)) {
						$verzendkosten = $this->config->get('postnl_briefpost_row_100');
						$discount_postnl = ($verzendkosten / 100) * $postnl_discount_world_std;
						$verzendkosten = $verzendkosten - $discount_postnl;
					} else {
						$verzendkosten = $this->config->get('postnl_briefpost_row_100');
					}
				}

				if ($weight > 100 && $weight <= 250) {
					if (isset($postnl_discount_world_std)) {
						$verzendkosten = $this->config->get('postnl_briefpost_row_250');
						$discount_postnl = ($verzendkosten / 100) * $postnl_discount_world_std;
						$verzendkosten = $verzendkosten - $discount_postnl;
					} else {
						$verzendkosten = $this->config->get('postnl_briefpost_row_250');
					}
				}

				if ($weight > 250 && $weight <= 500) {
					if (isset($postnl_discount_world_std)) {
						$verzendkosten = $this->config->get('postnl_briefpost_row_500');
						$discount_postnl = ($verzendkosten / 100) * $postnl_discount_world_std;
						$verzendkosten = $verzendkosten - $discount_postnl;
					} else {
						$verzendkosten = $this->config->get('postnl_briefpost_row_500');
					}
				}

				if ($weight > 500 && $weight < 2000) {
					if (isset($postnl_discount_world_std)) {
						$verzendkosten = $this->config->get('postnl_briefpost_row_2000');
						$discount_postnl = ($verzendkosten / 100) * $postnl_discount_world_std;
						$verzendkosten = $verzendkosten - $discount_postnl;
					} else {
						$verzendkosten = $this->config->get('postnl_briefpost_row_2000');
					}
				}

				if ($weight <= 0) {
					$error = $this->language->get('error_zero_weight');
				}

				if ($this->config->get('postnl_display_weight')) {
					$show_weight = $show_weight + $boxweight;
					$title .= '<span class="help">' . $this->language->get('text_weight') . ' ' . $show_weight . ' ' . $kg . '</span>';
				}

				if ($this->config->get('postnl_display_time')) {
					$title .= $this->language->get('text_eta_next_day');
				}


				$quote_data['postnl_briefpost_row'] = array(
					'code' => 'postnl.postnl_briefpost_row',
					'title' => $title,
					'cost' => $verzendkosten,
					'tax_class_id' => $this->config->get('postnl_tax_class_id'),
					'text' => $this->currency->format($this->tax->calculate($verzendkosten, $this->config->get('postnl_tax_class_id'), $this->config->get('config_tax')))
					);
			}

			// Brievenpost aantekenen Rest of World
			$countries = explode(',', 'BE,DK,DE,FR,IT,LU,MC,AT,ES,GB,SE,BG,EE,FI,HU,IE,LV,LT,PL,PT,RO,SI,SK,CZ,AL,AD,CH,
						   VA,CY,BY,GI,GR,GL,IS,JE,HR,LI,MD,ME,MK,MT,NO,UA,SM,RS,TR,IM,GG,BA,FO,NL');

			if ($this->config->get('postnl_briefpost_row_rb02') && $weight < 2000 && !in_array($address['iso_code_2'], $countries)) {
				$cost = 0;

				$title_postnl = $this->language->get('text_title_nl');
				$title = $this->language->get('text_postnl_briefpost_aantekenen_row');

				$discount_postnl = 0;
				$postnl_discount_world_aan = $this->config->get('postnl_discount_world_aan');

				if ($weight > 0 && $weight < 2000) {
					if (isset($postnl_discount_world_aan)) {
						$verzendkosten = $this->config->get('postnl_briefpost_aantekenen_row_2000');
						$discount_postnl = ($verzendkosten / 100) * $postnl_discount_world_aan;
						$verzendkosten = $verzendkosten - $discount_postnl;
					} else {
						$verzendkosten = $this->config->get('postnl_briefpost_aantekenen_row_2000');
					}
				}

				if ($weight <= 0) {
					$error = $this->language->get('error_zero_weight');
				}

				if ($this->config->get('postnl_display_weight')) {
					$show_weight = $show_weight + $boxweight;
					$title .= '<span class="help">' . $this->language->get('text_weight') . ' ' . $show_weight . ' ' . $kg . '</span>';
				}

				if ($this->config->get('postnl_display_time')) {
					$title .= $this->language->get('text_eta_next_day');
				}

				$quote_data['postnl_briefpost_aantekenen_row'] = array(
					'code' => 'postnl.postnl_briefpost_aantekenen_row',
					'title' => $title,
					'cost' => $verzendkosten,
					'tax_class_id' => $this->config->get('postnl_tax_class_id'),
					'text' => $this->currency->format($this->tax->calculate($verzendkosten, $this->config->get('postnl_tax_class_id'), $this->config->get('config_tax')))
					);
			}
		}
		// eind brievenbus post

		// begin pakket post
		if ($postnl_box == 0) {
			$weight = $weight + $cboxweight;
			$show_weight = $weight/1000;
			// Nederland Parcel
			if ($this->config->get('postnl_nl_rb01') && $address['iso_code_2'] == 'NL' && $sub_total <= $max_pakketwaarde) {
				$cost = 0;

				$title_postnl = $this->language->get('text_title_nl');
				$title = $this->language->get('text_postnl_nl');

				$discount_postnl = 0;
				$postnl_discount_nl_parcel_std = $this->config->get('postnl_discount_nl_parcel_std');

				if ($weight > 0 && $weight <= 10000) {
					if (isset($postnl_discount_nl_parcel_std)) {
						$verzendkosten = $this->config->get('postnl_nl_10');
						$discount_postnl = ($verzendkosten / 100) * $postnl_discount_nl_parcel_std;
						$verzendkosten = $verzendkosten - $discount_postnl;
					} else {
						$verzendkosten = $this->config->get('postnl_nl_10');
					}
				}

				if ($weight > 10000 && $weight <= 30000) {
					if (isset($postnl_discount_nl_parcel_std)) {
						$verzendkosten = $this->config->get('postnl_nl_30');
						$discount_postnl = ($verzendkosten / 100) * $postnl_discount_nl_parcel_std;
						$verzendkosten = $verzendkosten - $discount_postnl;
					} else {
						$verzendkosten = $this->config->get('postnl_nl_30');
					}
				}

				if ($weight <= 0) {
					$error = $this->language->get('error_zero_weight');
				}

				if ($weight > 30000) {
					$error = $this->language->get('error_over_weight');
				}

				if ($this->config->get('postnl_display_weight')) {
					$title .= '<span class="help">' . $this->language->get('text_weight') . ' ' . $show_weight . ' ' . $kg . '</span>';
				}

				if ($this->config->get('postnl_display_time')) {
					$title .= $this->language->get('text_eta_next_day');
				}


				$quote_data['postnl_nl'] = array(
					'code' => 'postnl.postnl_nl',
					'title' => $title,
					'cost' => $verzendkosten,
					'tax_class_id' => $this->config->get('postnl_tax_class_id'),
					'text' => $this->currency->format($this->tax->calculate($verzendkosten, $this->config->get('postnl_tax_class_id'), $this->config->get('config_tax')))
					);
			}

				// Nederland met Aantekenen
				if ($this->config->get('postnl_nl_rb02') && $address['iso_code_2'] == 'NL') {
					$cost = 0;

					$title_postnl = $this->language->get('text_title_nl');
					$title = $this->language->get('text_postnl_nl_aantekenen');

					$discount_postnl = 0;
					$postnl_discount_nl_parcel_aan = $this->config->get('postnl_discount_nl_parcel_aan');

					if ($weight > 0 && $weight <= 10000) {
						if (isset($postnl_discount_nl_parcel_aan)) {
							$verzendkosten = $this->config->get('postnl_nl_aantekenen_10');
							$discount_postnl = ($verzendkosten / 100) * $postnl_discount_nl_parcel_aan;
							$verzendkosten = $verzendkosten - $discount_postnl;
						} else {
							$verzendkosten = $this->config->get('postnl_nl_aantekenen_10');
						}
					}

					if ($weight > 10000 && $weight <= 30000) {
						if (isset($postnl_discount_nl_parcel_aan)) {
							$verzendkosten = $this->config->get('postnl_nl_aantekenen_30');
							$discount_postnl = ($verzendkosten / 100) * $postnl_discount_nl_parcel_aan;
							$verzendkosten = $verzendkosten - $discount_postnl;
						} else {
							$verzendkosten = $this->config->get('postnl_nl_aantekenen_30');
						}
					}

					if ($weight <= 0) {
						$error = $this->language->get('error_zero_weight');
					}

					if ($weight > 30000) {
						$error = $this->language->get('error_over_weight');
					}

					if ($this->config->get('postnl_display_weight')) {
						$title .= '<span class="help">' . $this->language->get('text_weight') . ' ' . $show_weight . ' ' . $kg . '</span>';
					}

					if ($this->config->get('postnl_display_time')) {
						$title .= $this->language->get('text_eta_next_day');
					}

					$quote_data['postnl_nl_aantekenen'] = array(
						'code' => 'postnl.postnl_nl_aantekenen',
						'title' => $title,
						'cost' => $verzendkosten,
						'tax_class_id' => $this->config->get('postnl_tax_class_id'),
						'text' => $this->currency->format($this->tax->calculate($verzendkosten, $this->config->get('postnl_tax_class_id'), $this->config->get('config_tax')))
						);
				}

				// Nederland met Verzekering
				if ($this->config->get('postnl_nl_rb03') && $address['iso_code_2'] == 'NL') {
					$cost = 0;

					$title_postnl = $this->language->get('text_title_nl');
					$title = $this->language->get('text_postnl_nl_verzekerd');

					$discount_postnl = 0;
					$postnl_discount_nl_parcel_ver = $this->config->get('postnl_discount_nl_parcel_ver');

					if ($weight > 0 && $weight <= 10000) {
						if (isset($postnl_discount_nl_parcel_ver)) {
							$verzendkosten = $this->config->get('postnl_nl_verzekerd_10');
							$discount_postnl = ($verzendkosten / 100) * $postnl_discount_nl_parcel_ver;
							$verzendkosten = $verzendkosten - $discount_postnl;
						} else {
							$verzendkosten = $this->config->get('postnl_nl_verzekerd_10');
						}
					}

					if ($weight > 10000 && $weight <= 30000) {
						if (isset($postnl_discount_nl_parcel_ver)) {
							$verzendkosten = $this->config->get('postnl_nl_verzekerd_30');
							$discount_postnl = ($verzendkosten / 100) * $postnl_discount_nl_parcel_ver;
							$verzendkosten = $verzendkosten - $discount_postnl;
						} else {
							$verzendkosten = $this->config->get('postnl_nl_verzekerd_30');
						}
					}

					if ($weight <= 0) {
						$error = $this->language->get('error_zero_weight');
					}

					if ($weight > 30000) {
						$error = $this->language->get('error_over_weight');
					}

					if ($this->config->get('postnl_display_weight')) {
						$title .= '<span class="help">' . $this->language->get('text_weight') . ' ' . $show_weight . ' ' . $kg . '</span>';
					}

					if ($this->config->get('postnl_display_time')) {
						$title .= $this->language->get('text_eta_next_day');
					}

					$quote_data['postnl_nl_verzekerd'] = array(
						'code' => 'postnl.postnl_nl_verzekerd',
						'title' => $title,
						'cost' => $verzendkosten,
						'tax_class_id' => $this->config->get('postnl_tax_class_id'),
						'text' => $this->currency->format($this->tax->calculate($verzendkosten, $this->config->get('postnl_tax_class_id'), $this->config->get('config_tax')))
						);
				}

				// Nederland Rembours
				if ($this->config->get('postnl_nl_rb04') && $address['iso_code_2'] == 'NL') {
					$cost = 0;

					$title_postnl = $this->language->get('text_title_nl');
					$title = $this->language->get('text_postnl_nl_rembours');

					$discount_postnl = 0;
					$postnl_discount_nl_parcel_rem = $this->config->get('postnl_discount_nl_parcel_rem');

					if ($weight > 0 && $weight <= 10000) {
						if (isset($postnl_discount_nl_parcel_rem)) {
							$verzendkosten = $this->config->get('postnl_nl_rembours_10');
							$discount_postnl = ($verzendkosten / 100) * $postnl_discount_nl_parcel_rem;
							$verzendkosten = $verzendkosten - $discount_postnl;
						} else {
							$verzendkosten = $this->config->get('postnl_nl_rembours_10');
						}
					}

					if ($weight > 10000 && $weight <= 30000) {
						if (isset($postnl_discount_nl_parcel_rem)) {
							$verzendkosten = $this->config->get('postnl_nl_rembours_30');
							$discount_postnl = ($verzendkosten / 100) * $postnl_discount_nl_parcel_rem;
							$verzendkosten = $verzendkosten - $discount_postnl;
						} else {
							$verzendkosten = $this->config->get('postnl_nl_rembours_30');
						}
					}

					if ($weight <= 0) {
						$error = $this->language->get('error_zero_weight');
					}

					if ($weight > 30000) {
						$error = $this->language->get('error_over_weight');
					}

					if ($this->config->get('postnl_display_weight')) {
						$title .= '<span class="help">' . $this->language->get('text_weight') . ' ' . $show_weight . ' ' . $kg . '</span>';
					}

					if ($this->config->get('postnl_display_time')) {
						$title .= $this->language->get('text_eta_next_day');
					}


					$quote_data['postnl_nl_rembours'] = array(
						'code' => 'postnl.postnl_nl_rembours',
						'title' => $title,
						'cost' => $verzendkosten,
						'tax_class_id' => $this->config->get('postnl_tax_class_id'),
						'text' => $this->currency->format($this->tax->calculate($verzendkosten, $this->config->get('postnl_tax_class_id'), $this->config->get('config_tax')))
						);
				}

			// Nederland Spoedbestelling
				if ($this->config->get('postnl_nl_rb05') && $weight <=10000 && $address['iso_code_2'] == 'NL') {
					$cost = 0;

					$title_postnl = $this->language->get('text_title_nl');
					$title = $this->language->get('text_postnl_nl_spoed');

					$discount_postnl = 0;
					$postnl_discount_nl_parcel_spoed = $this->config->get('postnl_discount_nl_parcel_spoed');

					if ($weight > 0 && $weight < 2000) {
						if (isset($postnl_discount_nl_parcel_spoed)) {
							$verzendkosten = $this->config->get('postnl_nl_spoed_02');
							$discount_postnl = ($verzendkosten / 100) * $postnl_discount_nl_parcel_spoed;
							$verzendkosten = $verzendkosten - $discount_postnl;
						} else {
							$verzendkosten = $this->config->get('postnl_nl_spoed_02');
						}
					}

					if ($weight > 2000 && $weight <= 5000) {
						if (isset($postnl_discount_nl_parcel_spoed)) {
							$verzendkosten = $this->config->get('postnl_nl_spoed_05');
							$discount_postnl = ($verzendkosten / 100) * $postnl_discount_nl_parcel_spoed;
							$verzendkosten = $verzendkosten - $discount_postnl;
						} else {
							$verzendkosten = $this->config->get('postnl_nl_spoed_05');
						}
					}

					if ($weight > 5000 && $weight <= 10000) {
						if (isset($postnl_discount_nl_parcel_spoed)) {
							$verzendkosten = $this->config->get('postnl_nl_spoed_10');
							$discount_postnl = ($verzendkosten / 100) * $postnl_discount_nl_parcel_spoed;
							$verzendkosten = $verzendkosten - $discount_postnl;
						} else {
							$verzendkosten = $this->config->get('postnl_nl_spoed_10');
						}
					}


					if ($weight <= 0) {
						$error = $this->language->get('error_zero_weight');
					}

					if ($weight > 10000) {
						$error = $this->language->get('error_over_weight');
					}

					if ($this->config->get('postnl_display_weight')) {
						$title .= '<span class="help">' . $this->language->get('text_weight') . ' ' . $show_weight . ' ' . $kg . '</span>';
					}

					if ($this->config->get('postnl_display_time')) {
						$title .= $this->language->get('text_eta_next_day');
					}


					$quote_data['postnl_nl_spoed'] = array(
						'code' => 'postnl.postnl_nl_spoed',
						'title' => $title,
						'cost' => $verzendkosten,
						'tax_class_id' => $this->config->get('postnl_tax_class_id'),
						'text' => $this->currency->format($this->tax->calculate($verzendkosten, $this->config->get('postnl_tax_class_id'), $this->config->get('config_tax')))
						);
				}

			// Europa I Pakketservice
			$countries = explode(',', 'BE,DK,DE,FR,IT,LU,MC,AT,ES,GB,SE');

			if ($this->config->get('postnl_eu1_rb01') && $weight <=30000 && $sub_total <= $max_pakketwaarde && in_array($address['iso_code_2'], $countries)) {
				$cost = 0;

				$title_postnl = $this->language->get('text_title_eu1');
				$title = $this->language->get('text_postnl_eu1');

				$discount_postnl = 0;
				$postnl_discount_eu1_parcel_std = $this->config->get('postnl_discount_eu1_parcel_std');

				if ($weight > 0 && $weight <= 2000) {
					if (isset($postnl_discount_eu1_parcel_std)) {
						$verzendkosten = $this->config->get('postnl_eu1_02');
						$discount_postnl = ($verzendkosten / 100) * $postnl_discount_eu1_parcel_std;
						$verzendkosten = $verzendkosten - $discount_postnl;
					} else {
						$verzendkosten = $this->config->get('postnl_eu1_02');
					}
				}

				if ($weight > 2000 && $weight <= 5000) {
					if (isset($postnl_discount_eu1_parcel_std)) {
						$verzendkosten = $this->config->get('postnl_eu1_05');
						$discount_postnl = ($verzendkosten / 100) * $postnl_discount_eu1_parcel_std;
						$verzendkosten = $verzendkosten - $discount_postnl;
					} else {
						$verzendkosten = $this->config->get('postnl_eu1_05');
					}
				}

				if ($weight > 5000 && $weight <= 10000) {
					if (isset($postnl_discount_eu1_parcel_std)) {
						$verzendkosten = $this->config->get('postnl_eu1_10');
						$discount_postnl = ($verzendkosten / 100) * $postnl_discount_eu1_parcel_std;
						$verzendkosten = $verzendkosten - $discount_postnl;
					} else {
						$verzendkosten = $this->config->get('postnl_eu1_10');
					}
				}

				if ($weight > 10000 && $weight <= 20000) {
					if (isset($postnl_discount_eu1_parcel_std)) {
						$verzendkosten = $this->config->get('postnl_eu1_20');
						$discount_postnl = ($verzendkosten / 100) * $postnl_discount_eu1_parcel_std;
						$verzendkosten = $verzendkosten - $discount_postnl;
					} else {
						$verzendkosten = $this->config->get('postnl_eu1_20');
					}				}

				if ($weight > 20000 && $weight <= 30000) {
					if (isset($postnl_discount_eu1_parcel_std)) {
						$verzendkosten = $this->config->get('postnl_eu1_30');
						$discount_postnl = ($verzendkosten / 100) * $postnl_discount_eu1_parcel_std;
						$verzendkosten = $verzendkosten - $discount_postnl;
					} else {
						$verzendkosten = $this->config->get('postnl_eu1_30');
					}
				}

				if ($weight <= 0) {
					$error = $this->language->get('error_zero_weight');
				}

				if ($weight > 30000) {
					$error = $this->language->get('error_over_weight');
				}

				if ($this->config->get('postnl_display_weight')) {
					$title .= '<span class="help">' . $this->language->get('text_weight') . ' ' . $show_weight . ' ' . $kg . '</span>';
				}

				if ($this->config->get('postnl_display_time')) {
					$title .= $this->language->get('text_eta_next_day');
				}

				$quote_data['postnl_eu1'] = array(
					'code' => 'postnl.postnl_eu1',
					'title' => $title,
					'cost' => $verzendkosten,
					'tax_class_id' => $this->config->get('postnl_tax_class_id'),
					'text' => $this->currency->format($this->tax->calculate($verzendkosten, $this->config->get('postnl_tax_class_id'), $this->config->get('config_tax')))
					);
			}


			// Europa I met Aantekenen
			$countries = explode(',', 'BE,DK,DE,FR,IT,LU,MC,AT,ES,GB,SE');

			if ($this->config->get('postnl_eu1_rb02') && $weight <=30000 && in_array($address['iso_code_2'], $countries)) {
				$cost = 0;

				$title_postnl = $this->language->get('text_title_eu1');
				$title = $this->language->get('text_postnl_eu1_aantekenen');

				$discount_postnl = 0;
				$postnl_discount_eu1_parcel_aan = $this->config->get('postnl_discount_eu1_parcel_aan');

				if ($weight > 0 && $weight <= 2000) {
					if (isset($postnl_discount_eu1_parcel_aan)) {
						$verzendkosten = $this->config->get('postnl_eu1_aantekenen_02');
						$discount_postnl = ($verzendkosten / 100) * $postnl_discount_eu1_parcel_aan;
						$verzendkosten = $verzendkosten - $discount_postnl;
					} else {
						$verzendkosten = $this->config->get('postnl_eu1_aantekenen_02');
					}
				}

				if ($weight > 2000 && $weight <= 5000) {
					if (isset($postnl_discount_eu1_parcel_aan)) {
						$verzendkosten = $this->config->get('postnl_eu1_aantekenen_05');
						$discount_postnl = ($verzendkosten / 100) * $postnl_discount_eu1_parcel_aan;
						$verzendkosten = $verzendkosten - $discount_postnl;
					} else {
						$verzendkosten = $this->config->get('postnl_eu1_aantekenen_05');
					}
				}

				if ($weight > 5000 && $weight <= 10000) {
					if (isset($postnl_discount_eu1_parcel_aan)) {
						$verzendkosten = $this->config->get('postnl_eu1_aantekenen_10');
						$discount_postnl = ($verzendkosten / 100) * $postnl_discount_eu1_parcel_aan;
						$verzendkosten = $verzendkosten - $discount_postnl;
					} else {
						$verzendkosten = $this->config->get('postnl_eu1_aantekenen_10');
					}
				}

				if ($weight > 10000 && $weight <= 20000) {
					if (isset($postnl_discount_eu1_parcel_aan)) {
						$verzendkosten = $this->config->get('postnl_eu1_aantekenen_20');
						$discount_postnl = ($verzendkosten / 100) * $postnl_discount_eu1_parcel_aan;
						$verzendkosten = $verzendkosten - $discount_postnl;
					} else {
						$verzendkosten = $this->config->get('postnl_eu1_aantekenen_20');
					}
				}

				if ($weight > 20000 && $weight <= 30000) {
					if (isset($postnl_discount_eu1_parcel_aan)) {
						$verzendkosten = $this->config->get('postnl_eu1_aantekenen_30');
						$discount_postnl = ($verzendkosten / 100) * $postnl_discount_eu1_parcel_aan;
						$verzendkosten = $verzendkosten - $discount_postnl;
					} else {
						$verzendkosten = $this->config->get('postnl_eu1_aantekenen_30');
					}
				}

				if ($weight <= 0) {
					$error = $this->language->get('error_zero_weight');
				}

				if ($weight > 30000) {
					$error = $this->language->get('error_over_weight');
				}

				if ($this->config->get('postnl_display_weight')) {
					$title .= '<span class="help">' . $this->language->get('text_weight') . ' ' . $show_weight . ' ' . $kg . '</span>';
				}

				if ($this->config->get('postnl_display_time')) {
					$title .= $this->language->get('text_eta_next_day');
				}

				$quote_data['postnl_eu1_aantekenen'] = array(
					'code' => 'postnl.postnl_eu1_aantekenen',
					'title' => $title,
					'cost' => $verzendkosten,
					'tax_class_id' => $this->config->get('postnl_tax_class_id'),
					'text' => $this->currency->format($this->tax->calculate($verzendkosten, $this->config->get('postnl_tax_class_id'), $this->config->get('config_tax')))
					);
			}

			// Europa I met Verzekering
			$countries = explode(',', 'BE,DK,DE,FR,IT,LU,MC,AT,ES,GB,SE');

			if ($this->config->get('postnl_eu1_rb03') && $weight <=30000 && in_array($address['iso_code_2'], $countries)) {
				$cost = 0;

				$title_postnl = $this->language->get('text_title_eu1');
				$title = $this->language->get('text_postnl_eu1_verzekerd');

				$discount_postnl = 0;
				$postnl_discount_eu1_parcel_ver = $this->config->get('postnl_discount_eu1_parcel_ver');

				if ($weight > 0 && $weight <= 2000) {
					if (isset($postnl_discount_eu1_parcel_ver)) {
						$verzendkosten = $this->config->get('postnl_eu1_verzekerd_02');
						$discount_postnl = ($verzendkosten / 100) * $postnl_discount_eu1_parcel_ver;
						$verzendkosten = $verzendkosten - $discount_postnl;
					} else {
						$verzendkosten = $this->config->get('postnl_eu1_verzekerd_02');
					}
				}

				if ($weight > 2000 && $weight <= 5000) {
					if (isset($postnl_discount_eu1_parcel_ver)) {
						$verzendkosten = $this->config->get('postnl_eu1_verzekerd_05');
						$discount_postnl = ($verzendkosten / 100) * $postnl_discount_eu1_parcel_ver;
						$verzendkosten = $verzendkosten - $discount_postnl;
					} else {
						$verzendkosten = $this->config->get('postnl_eu1_verzekerd_05');
					}
				}

				if ($weight > 5000 && $weight <= 10000) {
					if (isset($postnl_discount_eu1_parcel_ver)) {
						$verzendkosten = $this->config->get('postnl_eu1_verzekerd_10');
						$discount_postnl = ($verzendkosten / 100) * $postnl_discount_eu1_parcel_ver;
						$verzendkosten = $verzendkosten - $discount_postnl;
					} else {
						$verzendkosten = $this->config->get('postnl_eu1_verzekerd_10');
					}
				}

				if ($weight > 10000 && $weight <= 20000) {
					if (isset($postnl_discount_eu1_parcel_ver)) {
						$verzendkosten = $this->config->get('postnl_eu1_verzekerd_20');
						$discount_postnl = ($verzendkosten / 100) * $postnl_discount_eu1_parcel_ver;
						$verzendkosten = $verzendkosten - $discount_postnl;
					} else {
						$verzendkosten = $this->config->get('postnl_eu1_verzekerd_20');
					}
				}

				if ($weight > 20000 && $weight <= 30000) {
					if (isset($postnl_discount_eu1_parcel_ver)) {
						$verzendkosten = $this->config->get('postnl_eu1_verzekerd_30');
						$discount_postnl = ($verzendkosten / 100) * $postnl_discount_eu1_parcel_ver;
						$verzendkosten = $verzendkosten - $discount_postnl;
					} else {
						$verzendkosten = $this->config->get('postnl_eu1_verzekerd_30');
					}
				}

				if ($weight <= 0) {
					$error = $this->language->get('error_zero_weight');
				}

				if ($weight > 30000) {
					$error = $this->language->get('error_over_weight');
				}

				if ($this->config->get('postnl_display_weight')) {
					$title .= '<span class="help">' . $this->language->get('text_weight') . ' ' . $show_weight . ' ' . $kg . '</span>';
				}

				if ($this->config->get('postnl_display_time')) {
					$title .= $this->language->get('text_eta_next_day');
				}

				$quote_data['postnl_eu1_verzekerd'] = array(
					'code' => 'postnl.postnl_eu1_verzekerd',
					'title' => $title,
					'cost' => $verzendkosten,
					'tax_class_id' => $this->config->get('postnl_tax_class_id'),
					'text' => $this->currency->format($this->tax->calculate($verzendkosten, $this->config->get('postnl_tax_class_id'), $this->config->get('config_tax')))
					);
			}

//			// Europa I Spoedbestelling
			$countries = explode(',', 'BE,DK,DE,FR,IT,LU,MC,AT,ES,GB,SE');

			if ($this->config->get('postnl_eu1_rb05') && $weight <=10000 && in_array($address['iso_code_2'], $countries)) {
				$cost = 0;

				$title_postnl = $this->language->get('text_title_eu1');
				$title = $this->language->get('text_postnl_eu1_spoed');

				$discount_postnl = 0;
				$postnl_discount_eu1_parcel_spoed = $this->config->get('postnl_discount_eu1_parcel_spoed');

				if ($weight > 0 && $weight <= 2000) {
					if (isset($postnl_discount_eu1_parcel_spoed)) {
						$verzendkosten = $this->config->get('postnl_eu1_spoed_02');
						$discount_postnl = ($verzendkosten / 100) * $postnl_discount_eu1_parcel_spoed;
						$verzendkosten = $verzendkosten - $discount_postnl;
					} else {
						$verzendkosten = $this->config->get('postnl_eu1_spoed_02');
					}
				}

				if ($weight > 2000 && $weight <= 5000) {
					if (isset($postnl_discount_eu1_parcel_spoed)) {
						$verzendkosten = $this->config->get('postnl_eu1_spoed_05');
						$discount_postnl = ($verzendkosten / 100) * $postnl_discount_eu1_parcel_spoed;
						$verzendkosten = $verzendkosten - $discount_postnl;
					} else {
						$verzendkosten = $this->config->get('postnl_eu1_spoed_05');
					}
				}

				if ($weight > 5000 && $weight <= 10000) {
					if (isset($postnl_discount_eu1_parcel_spoed)) {
						$verzendkosten = $this->config->get('postnl_eu1_spoed_10');
						$discount_postnl = ($verzendkosten / 100) * $postnl_discount_eu1_parcel_spoed;
						$verzendkosten = $verzendkosten - $discount_postnl;
					} else {
						$verzendkosten = $this->config->get('postnl_eu1_spoed_10');
					}
				}


				if ($weight <= 0) {
					$error = $this->language->get('error_zero_weight');
				}

				if ($weight > 10000) {
					$error = $this->language->get('error_over_weight');
				}

				if ($this->config->get('postnl_display_weight')) {
					$title .= '<span class="help">' . $this->language->get('text_weight') . ' ' . $show_weight . ' ' . $kg . '</span>';
				}

				if ($this->config->get('postnl_display_time')) {
					$title .= $this->language->get('text_eta_next_day');
				}

				$quote_data['postnl_eu1_spoed'] = array(
					'code' => 'postnl.postnl_eu1_spoed',
					'title' => $title,
					'cost' => $verzendkosten,
					'tax_class_id' => $this->config->get('postnl_tax_class_id'),
					'text' => $this->currency->format($this->tax->calculate($verzendkosten, $this->config->get('postnl_tax_class_id'), $this->config->get('config_tax')))
					);
			}


			// Europa II Pakketservice
			$countries = explode(',', 'BG,EE,FI,HU,IE,LV,LT,PL,PT,RO,SI,SK,CZ');

			if ($this->config->get('postnl_eu2_rb01') && $weight <=30000 && $sub_total <= $max_pakketwaarde && in_array($address['iso_code_2'], $countries)) {
				$cost = 0;

				$title_postnl = $this->language->get('text_title_eu2');
				$title = $this->language->get('text_postnl_eu2');

				$discount_postnl = 0;
				$postnl_discount_eu2_parcel_std = $this->config->get('postnl_discount_eu2_parcel_std');

				if ($weight > 0 && $weight <= 2000) {
					if (isset($postnl_discount_eu2_parcel_std)) {
						$verzendkosten = $this->config->get('postnl_eu2_02');
						$discount_postnl = ($verzendkosten / 100) * $postnl_discount_eu2_parcel_std;
						$verzendkosten = $verzendkosten - $discount_postnl;
					} else {
						$verzendkosten = $this->config->get('postnl_eu2_02');
					}
				}

				if ($weight > 2000 && $weight <= 5000) {
					if (isset($postnl_discount_eu2_parcel_std)) {
						$verzendkosten = $this->config->get('postnl_eu2_05');
						$discount_postnl = ($verzendkosten / 100) * $postnl_discount_eu2_parcel_std;
						$verzendkosten = $verzendkosten - $discount_postnl;
					} else {
						$verzendkosten = $this->config->get('postnl_eu2_05');
					}
				}

				if ($weight > 5000 && $weight <= 10000) {
					if (isset($postnl_discount_eu2_parcel_std)) {
						$verzendkosten = $this->config->get('postnl_eu2_10');
						$discount_postnl = ($verzendkosten / 100) * $postnl_discount_eu2_parcel_std;
						$verzendkosten = $verzendkosten - $discount_postnl;
					} else {
						$verzendkosten = $this->config->get('postnl_eu2_10');
					}
				}

				if ($weight > 10000 && $weight <= 20000) {
					if (isset($postnl_discount_eu2_parcel_std)) {
						$verzendkosten = $this->config->get('postnl_eu2_20');
						$discount_postnl = ($verzendkosten / 100) * $postnl_discount_eu2_parcel_std;
						$verzendkosten = $verzendkosten - $discount_postnl;
					} else {
						$verzendkosten = $this->config->get('postnl_eu2_20');
					}
				}

				if ($weight > 20000 && $weight <= 30000) {
					if (isset($postnl_discount_eu2_parcel_std)) {
						$verzendkosten = $this->config->get('postnl_eu2_30');
						$discount_postnl = ($verzendkosten / 100) * $postnl_discount_eu2_parcel_std;
						$verzendkosten = $verzendkosten - $discount_postnl;
					} else {
						$verzendkosten = $this->config->get('postnl_eu2_30');
					}
				}

				if ($weight <= 0) {
					$error = $this->language->get('error_zero_weight');
				}

				if ($weight > 30000) {
					$error = $this->language->get('error_over_weight');
				}

				if ($this->config->get('postnl_display_weight')) {
					$title .= '<span class="help">' . $this->language->get('text_weight') . ' ' . $show_weight . ' ' . $kg . '</span>';
				}

				if ($this->config->get('postnl_display_time')) {
					$title .= $this->language->get('text_eta_three');
				}

				$quote_data['postnl_eu2'] = array(
					'code' => 'postnl.postnl_eu2',
					'title' => $title,
					'cost' => $verzendkosten,
					'tax_class_id' => $this->config->get('postnl_tax_class_id'),
					'text' => $this->currency->format($this->tax->calculate($verzendkosten, $this->config->get('postnl_tax_class_id'), $this->config->get('config_tax')))
					);
			}


			// Europa II met Aantekenen
			$countries = explode(',', 'BG,EE,FI,HU,IE,LV,LT,PL,PT,RO,SI,SK,CZ');

			if ($this->config->get('postnl_eu2_rb02') && $weight <=30000 && in_array($address['iso_code_2'], $countries)) {
				$cost = 0;

				$title_postnl = $this->language->get('text_title_eu2');
				$title = $this->language->get('text_postnl_eu2_aantekenen');

				$discount_postnl = 0;
				$postnl_discount_eu2_parcel_aan = $this->config->get('postnl_discount_eu2_parcel_aan');

				if ($weight > 0 && $weight <= 2000) {
					if (isset($postnl_discount_eu2_parcel_aan)) {
						$verzendkosten = $this->config->get('postnl_eu2_aantekenen_02');
						$discount_postnl = ($verzendkosten / 100) * $postnl_discount_eu2_parcel_aan;
						$verzendkosten = $verzendkosten - $discount_postnl;
					} else {
						$verzendkosten = $this->config->get('postnl_eu2_aantekenen_02');
					}
				}

				if ($weight > 2000 && $weight <= 5000) {
					if (isset($postnl_discount_eu2_parcel_aan)) {
						$verzendkosten = $this->config->get('postnl_eu2_aantekenen_05');
						$discount_postnl = ($verzendkosten / 100) * $postnl_discount_eu2_parcel_aan;
						$verzendkosten = $verzendkosten - $discount_postnl;
					} else {
						$verzendkosten = $this->config->get('postnl_eu2_aantekenen_05');
					}
				}

				if ($weight > 5000 && $weight <= 10000) {
					if (isset($postnl_discount_eu2_parcel_aan)) {
						$verzendkosten = $this->config->get('postnl_eu2_aantekenen_10');
						$discount_postnl = ($verzendkosten / 100) * $postnl_discount_eu2_parcel_aan;
						$verzendkosten = $verzendkosten - $discount_postnl;
					} else {
						$verzendkosten = $this->config->get('postnl_eu2_aantekenen_10');
					}
				}

				if ($weight > 10000 && $weight <= 20000) {
					if (isset($postnl_discount_eu2_parcel_aan)) {
						$verzendkosten = $this->config->get('postnl_eu2_aantekenen_20');
						$discount_postnl = ($verzendkosten / 100) * $postnl_discount_eu2_parcel_aan;
						$verzendkosten = $verzendkosten - $discount_postnl;
					} else {
						$verzendkosten = $this->config->get('postnl_eu2_aantekenen_20');
					}
				}

				if ($weight > 20000 && $weight <= 30000) {
					if (isset($postnl_discount_eu2_parcel_aan)) {
						$verzendkosten = $this->config->get('postnl_eu2_aantekenen_30');
						$discount_postnl = ($verzendkosten / 100) * $postnl_discount_eu2_parcel_aan;
						$verzendkosten = $verzendkosten - $discount_postnl;
					} else {
						$verzendkosten = $this->config->get('postnl_eu2_aantekenen_30');
					}
				}

				if ($weight <= 0) {
					$error = $this->language->get('error_zero_weight');
				}

				if ($weight > 30000) {
					$error = $this->language->get('error_over_weight');
				}

				if ($this->config->get('postnl_display_weight')) {
					$title .= '<span class="help">' . $this->language->get('text_weight') . ' ' . $show_weight . ' ' . $kg . '</span>';
				}

				if ($this->config->get('postnl_display_time')) {
					$title .= $this->language->get('text_eta_three');
				}

				$quote_data['postnl_eu2_aantekenen'] = array(
					'code' => 'postnl.postnl_eu2_aantekenen',
					'title' => $title,
					'cost' => $verzendkosten,
					'tax_class_id' => $this->config->get('postnl_tax_class_id'),
					'text' => $this->currency->format($this->tax->calculate($verzendkosten, $this->config->get('postnl_tax_class_id'), $this->config->get('config_tax')))
					);
			}

			// Europa II met Verzekering
			$countries = explode(',', 'BG,EE,FI,HU,IE,LV,LT,PL,PT,RO,SI,SK,CZ');

			if ($this->config->get('postnl_eu2_rb03') && $weight <=30000 && in_array($address['iso_code_2'], $countries)) {
				$cost = 0;

				$title_postnl = $this->language->get('text_title_eu2');
				$title = $this->language->get('text_postnl_eu2_verzekerd');

				$discount_postnl = 0;
				$postnl_discount_eu2_parcel_ver = $this->config->get('postnl_discount_eu2_parcel_ver');

				if ($weight > 0 && $weight <= 2000) {
					if (isset($postnl_discount_eu2_parcel_ver)) {
						$verzendkosten = $this->config->get('postnl_eu2_verzekerd_02');
						$discount_postnl = ($verzendkosten / 100) * $postnl_discount_eu2_parcel_ver;
						$verzendkosten = $verzendkosten - $discount_postnl;
					} else {
						$verzendkosten = $this->config->get('postnl_eu2_verzekerd_02');
					}
				}

				if ($weight > 2000 && $weight <= 5000) {
					if (isset($postnl_discount_eu2_parcel_ver)) {
						$verzendkosten = $this->config->get('postnl_eu2_verzekerd_05');
						$discount_postnl = ($verzendkosten / 100) * $postnl_discount_eu2_parcel_ver;
						$verzendkosten = $verzendkosten - $discount_postnl;
					} else {
						$verzendkosten = $this->config->get('postnl_eu2_verzekerd_05');
					}
				}

				if ($weight > 5000 && $weight <= 10000) {
					if (isset($postnl_discount_eu2_parcel_ver)) {
						$verzendkosten = $this->config->get('postnl_eu2_verzekerd_10');
						$discount_postnl = ($verzendkosten / 100) * $postnl_discount_eu2_parcel_ver;
						$verzendkosten = $verzendkosten - $discount_postnl;
					} else {
						$verzendkosten = $this->config->get('postnl_eu2_verzekerd_10');
					}
				}

				if ($weight > 10000 && $weight <= 20000) {
					if (isset($postnl_discount_eu2_parcel_ver)) {
						$verzendkosten = $this->config->get('postnl_eu2_verzekerd_20');
						$discount_postnl = ($verzendkosten / 100) * $postnl_discount_eu2_parcel_ver;
						$verzendkosten = $verzendkosten - $discount_postnl;
					} else {
						$verzendkosten = $this->config->get('postnl_eu2_verzekerd_20');
					}
				}

				if ($weight > 20000 && $weight <= 30000) {
					if (isset($postnl_discount_eu2_parcel_ver)) {
						$verzendkosten = $this->config->get('postnl_eu2_verzekerd_30');
						$discount_postnl = ($verzendkosten / 100) * $postnl_discount_eu2_parcel_ver;
						$verzendkosten = $verzendkosten - $discount_postnl;
					} else {
						$verzendkosten = $this->config->get('postnl_eu2_verzekerd_30');
					}
				}

				if ($weight <= 0) {
					$error = $this->language->get('error_zero_weight');
				}

				if ($weight > 30000) {
					$error = $this->language->get('error_over_weight');
				}

				if ($this->config->get('postnl_display_weight')) {
					$title .= '<span class="help">' . $this->language->get('text_weight') . ' ' . $show_weight . ' ' . $kg . '</span>';
				}

				if ($this->config->get('postnl_display_time')) {
					$title .= $this->language->get('text_eta_three');
				}

				$quote_data['postnl_eu2_verzekerd'] = array(
					'code' => 'postnl.postnl_eu2_verzekerd',
					'title' => $title,
					'cost' => $verzendkosten,
					'tax_class_id' => $this->config->get('postnl_tax_class_id'),
					'text' => $this->currency->format($this->tax->calculate($verzendkosten, $this->config->get('postnl_tax_class_id'), $this->config->get('config_tax')))
					);
			}

			// Europa II Spoedbestelling
			$countries = explode(',', 'BG,EE,FI,HU,IE,LV,LT,PL,PT,RO,SI,SK,CZ');

			if ($this->config->get('postnl_eu2_rb05') && $weight <=10000 && in_array($address['iso_code_2'], $countries)) {
				$cost = 0;

				$title_postnl = $this->language->get('text_title_eu2');
				$title = $this->language->get('text_postnl_eu2_spoed');

				$discount_postnl = 0;
				$postnl_discount_eu2_parcel_spoed = $this->config->get('postnl_discount_eu2_parcel_spoed');

				if ($weight > 0 && $weight <= 2000) {
					if (isset($postnl_discount_eu2_parcel_spoed)) {
						$verzendkosten = $this->config->get('postnl_eu2_spoed_02');
						$discount_postnl = ($verzendkosten / 100) * $postnl_discount_eu2_parcel_spoed;
						$verzendkosten = $verzendkosten - $discount_postnl;
					} else {
						$verzendkosten = $this->config->get('postnl_eu2_spoed_02');
					}
				}

				if ($weight > 2000 && $weight <= 5000) {
					if (isset($postnl_discount_eu2_parcel_spoed)) {
						$verzendkosten = $this->config->get('postnl_eu2_spoed_05');
						$discount_postnl = ($verzendkosten / 100) * $postnl_discount_eu2_parcel_spoed;
						$verzendkosten = $verzendkosten - $discount_postnl;
					} else {
						$verzendkosten = $this->config->get('postnl_eu2_spoed_05');
					}
				}

				if ($weight > 5000 && $weight <= 10000) {
					if (isset($postnl_discount_eu2_parcel_spoed)) {
						$verzendkosten = $this->config->get('postnl_eu2_spoed_10');
						$discount_postnl = ($verzendkosten / 100) * $postnl_discount_eu2_parcel_spoed;
						$verzendkosten = $verzendkosten - $discount_postnl;
					} else {
						$verzendkosten = $this->config->get('postnl_eu2_spoed_10');
					}
				}


				if ($weight <= 0) {
					$error = $this->language->get('error_zero_weight');
				}

				if ($weight > 10000) {
					$error = $this->language->get('error_over_weight');
				}

				if ($this->config->get('postnl_display_weight')) {
					$title .= '<span class="help">' . $this->language->get('text_weight') . ' ' . $show_weight . ' ' . $kg . '</span>';
				}

				if ($this->config->get('postnl_display_time')) {
					$title .= $this->language->get('text_eta_three');
				}

				$quote_data['postnl_eu2_spoed'] = array(
					'code' => 'postnl.postnl_eu2_spoed',
					'title' => $title,
					'cost' => $verzendkosten,
					'tax_class_id' => $this->config->get('postnl_tax_class_id'),
					'text' => $this->currency->format($this->tax->calculate($verzendkosten, $this->config->get('postnl_tax_class_id'), $this->config->get('config_tax')))
					);
			}

			// Europa III Pakketservice
			$countries = explode(',', 'AL,AD,CH,VA,CY,BY,GI,GR,GL,IS,JE,HR,LI,MD,ME,MK,MT,NO,UA,SM,RS,TR,IM,GG,BA,FO');

			if ($this->config->get('postnl_eu3_rb01') && $weight <=20000 && $sub_total <= $max_pakketwaarde && in_array($address['iso_code_2'], $countries)) {
				$cost = 0;

				$title_postnl = $this->language->get('text_title_eu3');
				$title = $this->language->get('text_postnl_eu3');

				$discount_postnl = 0;
				$postnl_discount_eu3_parcel_std = $this->config->get('postnl_discount_eu3_parcel_std');


				if ($weight > 0 && $weight <= 2000) {
					if (isset($postnl_discount_eu3_parcel_std)) {
						$verzendkosten = $this->config->get('postnl_eu3_02');
						$discount_postnl = ($verzendkosten / 100) * $postnl_discount_eu3_parcel_std;
						$verzendkosten = $verzendkosten - $discount_postnl;
					} else {
						$verzendkosten = $this->config->get('postnl_eu3_02');
					}
				}

				if ($weight > 2000 && $weight <= 5000) {
					if (isset($postnl_discount_eu3_parcel_std)) {
						$verzendkosten = $this->config->get('postnl_eu3_05');
						$discount_postnl = ($verzendkosten / 100) * $postnl_discount_eu3_parcel_std;
						$verzendkosten = $verzendkosten - $discount_postnl;
					} else {
						$verzendkosten = $this->config->get('postnl_eu3_05');
					}
				}

				if ($weight > 5000 && $weight <= 10000) {
					if (isset($postnl_discount_eu3_parcel_std)) {
						$verzendkosten = $this->config->get('postnl_eu3_10');
						$discount_postnl = ($verzendkosten / 100) * $postnl_discount_eu3_parcel_std;
						$verzendkosten = $verzendkosten - $discount_postnl;
					} else {
						$verzendkosten = $this->config->get('postnl_eu3_10');
					}
				}

				if ($weight > 10000 && $weight <= 20000) {
					if (isset($postnl_discount_eu3_parcel_std)) {
						$verzendkosten = $this->config->get('postnl_eu3_20');
						$discount_postnl = ($verzendkosten / 100) * $postnl_discount_eu3_parcel_std;
						$verzendkosten = $verzendkosten - $discount_postnl;
					} else {
						$verzendkosten = $this->config->get('postnl_eu3_20');
					}
				}


				if ($weight <= 0) {
					$error = $this->language->get('error_zero_weight');
				}

				if ($weight > 20000) {
					$error = $this->language->get('error_over_weight');
				}

				if ($this->config->get('postnl_display_weight')) {
					$title .= '<span class="help">' . $this->language->get('text_weight') . ' ' . $show_weight . ' ' . $kg . '</span>';
				}

				if ($this->config->get('postnl_display_time')) {
					$title .= $this->language->get('text_eta_five');
				}

				$quote_data['postnl_eu3'] = array(
					'code' => 'postnl.postnl_eu3',
					'title' => $title,
					'cost' => $verzendkosten,
					'tax_class_id' => $this->config->get('postnl_tax_class_id'),
					'text' => $this->currency->format($this->tax->calculate($verzendkosten, $this->config->get('postnl_tax_class_id'), $this->config->get('config_tax')))
					);
			}


			// Europa III met Aantekenen
			$countries = explode(',', 'AL,AD,CH,VA,CY,BY,GI,GR,GL,IS,JE,HR,LI,MD,ME,MK,MT,NO,UA,SM,RS,TR,IM,GG,BA,FO');

			if ($this->config->get('postnl_eu3_rb02') && $weight <=20000 && in_array($address['iso_code_2'], $countries)) {
				$cost = 0;

				$title_postnl = $this->language->get('text_title_eu3');
				$title = $this->language->get('text_postnl_eu3_aantekenen');

				$discount_postnl = 0;
				$postnl_discount_eu3_parcel_aan = $this->config->get('postnl_discount_eu3_parcel_aan');

				if ($weight > 0 && $weight <= 2000) {
					if (isset($postnl_discount_eu3_parcel_aan)) {
						$verzendkosten = $this->config->get('postnl_eu3_aantekenen_02');
						$discount_postnl = ($verzendkosten / 100) * $postnl_discount_eu3_parcel_aan;
						$verzendkosten = $verzendkosten - $discount_postnl;
					} else {
						$verzendkosten = $this->config->get('postnl_eu3_aantekenen_02');
					}
				}

				if ($weight > 2000 && $weight <= 5000) {
					if (isset($postnl_discount_eu3_parcel_aan)) {
						$verzendkosten = $this->config->get('postnl_eu3_aantekenen_05');
						$discount_postnl = ($verzendkosten / 100) * $postnl_discount_eu3_parcel_aan;
						$verzendkosten = $verzendkosten - $discount_postnl;
					} else {
						$verzendkosten = $this->config->get('postnl_eu3_aantekenen_05');
					}
				}

				if ($weight > 5000 && $weight <= 10000) {
					if (isset($postnl_discount_eu3_parcel_aan)) {
						$verzendkosten = $this->config->get('postnl_eu3_aantekenen_10');
						$discount_postnl = ($verzendkosten / 100) * $postnl_discount_eu3_parcel_aan;
						$verzendkosten = $verzendkosten - $discount_postnl;
					} else {
						$verzendkosten = $this->config->get('postnl_eu3_aantekenen_10');
					}
				}

				if ($weight > 10000 && $weight <= 20000) {
					if (isset($postnl_discount_eu3_parcel_aan)) {
						$verzendkosten = $this->config->get('postnl_eu3_aantekenen_20');
						$discount_postnl = ($verzendkosten / 100) * $postnl_discount_eu3_parcel_aan;
						$verzendkosten = $verzendkosten - $discount_postnl;
					} else {
						$verzendkosten = $this->config->get('postnl_eu3_aantekenen_20');
					}
				}


				if ($weight <= 0) {
					$error = $this->language->get('error_zero_weight');
				}

				if ($weight > 20000) {
					$error = $this->language->get('error_over_weight');
				}

				if ($this->config->get('postnl_display_weight')) {
					$title .= '<span class="help">' . $this->language->get('text_weight') . ' ' . $show_weight . ' ' . $kg . '</span>';
				}

				if ($this->config->get('postnl_display_time')) {
					$title .= $this->language->get('text_eta_five');
				}

				$quote_data['postnl_eu3_aantekenen'] = array(
					'code' => 'postnl.postnl_eu3_aantekenen',
					'title' => $title,
					'cost' => $verzendkosten,
					'tax_class_id' => $this->config->get('postnl_tax_class_id'),
					'text' => $this->currency->format($this->tax->calculate($verzendkosten, $this->config->get('postnl_tax_class_id'), $this->config->get('config_tax')))
					);
			}

			// Europa III met Verzekering
			$countries = explode(',', 'AL,AD,CH,VA,CY,BY,GI,GR,GL,IS,JE,HR,LI,MD,ME,MK,MT,NO,UA,SM,RS,TR,IM,GG,BA,FO');

			if ($this->config->get('postnl_eu3_rb03') && $weight <=20000 && in_array($address['iso_code_2'], $countries)) {
				$cost = 0;

				$title_postnl = $this->language->get('text_title_eu3');
				$title = $this->language->get('text_postnl_eu3_verzekerd');

				$discount_postnl = 0;
				$postnl_discount_eu3_parcel_ver = $this->config->get('postnl_discount_eu3_parcel_ver');

				if ($weight > 0 && $weight <= 2000) {
					if (isset($postnl_discount_eu3_parcel_ver)) {
						$verzendkosten = $this->config->get('postnl_eu3_verzekerd_02');
						$discount_postnl = ($verzendkosten / 100) * $postnl_discount_eu3_parcel_ver;
						$verzendkosten = $verzendkosten - $discount_postnl;
					} else {
						$verzendkosten = $this->config->get('postnl_eu3_verzekerd_02');
					}
				}

				if ($weight > 2000 && $weight <= 5000) {
					if (isset($postnl_discount_eu3_parcel_ver)) {
						$verzendkosten = $this->config->get('postnl_eu3_verzekerd_05');
						$discount_postnl = ($verzendkosten / 100) * $postnl_discount_eu3_parcel_ver;
						$verzendkosten = $verzendkosten - $discount_postnl;
					} else {
						$verzendkosten = $this->config->get('postnl_eu3_verzekerd_05');
					}
				}

				if ($weight > 5000 && $weight <= 10000) {
					if (isset($postnl_discount_eu3_parcel_ver)) {
						$verzendkosten = $this->config->get('postnl_eu3_verzekerd_10');
						$discount_postnl = ($verzendkosten / 100) * $postnl_discount_eu3_parcel_ver;
						$verzendkosten = $verzendkosten - $discount_postnl;
					} else {
						$verzendkosten = $this->config->get('postnl_eu3_verzekerd_10');
					}
				}

				if ($weight > 10000 && $weight <= 20000) {
					if (isset($postnl_discount_eu3_parcel_ver)) {
						$verzendkosten = $this->config->get('postnl_eu3_verzekerd_20');
						$discount_postnl = ($verzendkosten / 100) * $postnl_discount_eu3_parcel_ver;
						$verzendkosten = $verzendkosten - $discount_postnl;
					} else {
						$verzendkosten = $this->config->get('postnl_eu3_verzekerd_20');
					}
				}

				if ($weight <= 0) {
					$error = $this->language->get('error_zero_weight');
				}

				if ($weight > 20000) {
					$error = $this->language->get('error_over_weight');
				}

				if ($this->config->get('postnl_display_weight')) {
					$title .= '<span class="help">' . $this->language->get('text_weight') . ' ' . $show_weight . ' ' . $kg . '</span>';
				}

				if ($this->config->get('postnl_display_time')) {
					$title .= $this->language->get('text_eta_five');
				}

				$quote_data['postnl_eu3_verzekerd'] = array(
					'code' => 'postnl.postnl_eu3_verzekerd',
					'title' => $title,
					'cost' => $verzendkosten,
					'tax_class_id' => $this->config->get('postnl_tax_class_id'),
					'text' => $this->currency->format($this->tax->calculate($verzendkosten, $this->config->get('postnl_tax_class_id'), $this->config->get('config_tax')))
					);
			}

			// Rest van de wereld Pakketservice
			$countries = explode(',', 'NL,BE,DK,DE,FR,IT,LU,MC,AT,ES,GB,SE,BG,EE,FI,HU,IE,LV,LT,PL,PT,RO,SI,SK,CZ,
									   AL,AD,CH,VA,CY,BY,GI,GR,GL,IS,JE,HR,LI,MD,ME,MK,MT,NO,UA,SM,RS,TR,IM,GG,BA,FO');

			if ($this->config->get('postnl_wereld_rb01') && $weight <=20000 && $sub_total <= $max_pakketwaarde && !(in_array($address['iso_code_2'], $countries))) {
				$cost = 0;

				$title_postnl = $this->language->get('text_title_wereld');
				$title = $this->language->get('text_postnl_wereld');

				$discount_postnl = 0;
				$postnl_discount_world_parcel_std = $this->config->get('postnl_discount_world_parcel_std');

				if ($weight > 0 && $weight <= 2000) {
					if (isset($postnl_discount_world_parcel_std)) {
						$verzendkosten = $this->config->get('postnl_wereld_02');
						$discount_postnl = ($verzendkosten / 100) * $postnl_discount_world_parcel_std;
						$verzendkosten = $verzendkosten - $discount_postnl;
					} else {
						$verzendkosten = $this->config->get('postnl_wereld_02');
					}
				}

				if ($weight > 2000 && $weight <= 5000) {
					if (isset($postnl_discount_world_parcel_std)) {
						$verzendkosten = $this->config->get('postnl_wereld_05');
						$discount_postnl = ($verzendkosten / 100) * $postnl_discount_world_parcel_std;
						$verzendkosten = $verzendkosten - $discount_postnl;
					} else {
						$verzendkosten = $this->config->get('postnl_wereld_05');
					}
				}

				if ($weight > 5000 && $weight <= 10000) {
					if (isset($postnl_discount_world_parcel_std)) {
						$verzendkosten = $this->config->get('postnl_wereld_10');
						$discount_postnl = ($verzendkosten / 100) * $postnl_discount_world_parcel_std;
						$verzendkosten = $verzendkosten - $discount_postnl;
					} else {
						$verzendkosten = $this->config->get('postnl_wereld_102');
					}
				}

				if ($weight > 10000 && $weight <= 20000) {
					if (isset($postnl_discount_world_parcel_std)) {
						$verzendkosten = $this->config->get('postnl_wereld_20');
						$discount_postnl = ($verzendkosten / 100) * $postnl_discount_world_parcel_std;
						$verzendkosten = $verzendkosten - $discount_postnl;
					} else {
						$verzendkosten = $this->config->get('postnl_wereld_20');
					}
				}


				if ($weight <= 0) {
					$error = $this->language->get('error_zero_weight');
				}

				if ($weight > 20000) {
					$error = $this->language->get('error_over_weight');
				}

				if ($this->config->get('postnl_display_weight')) {
					$title .= '<span class="help">' . $this->language->get('text_weight') . ' ' . $show_weight . ' ' . $kg . '</span>';
				}

				if ($this->config->get('postnl_display_time')) {
					$title .= $this->language->get('text_eta_ten');
				}

				$quote_data['postnl_wereld'] = array(
					'code' => 'postnl.postnl_wereld',
					'title' => $title,
					'cost' => $verzendkosten,
					'tax_class_id' => $this->config->get('postnl_tax_class_id'),
					'text' => $this->currency->format($this->tax->calculate($verzendkosten, $this->config->get('postnl_tax_class_id'), $this->config->get('config_tax')))
					);
			}


			// Rest van de wereld met Aantekenen
			$countries = explode(',', 'NL,BE,DK,DE,FR,IT,LU,MC,AT,ES,GB,SE,BG,EE,FI,HU,IE,LV,LT,PL,PT,RO,SI,SK,CZ,
						   AL,AD,CH,VA,CY,BY,GI,GR,GL,IS,JE,HR,LI,MD,ME,MK,MT,NO,UA,SM,RS,TR,IM,GG,BA,FO');

			if ($this->config->get('postnl_wereld_rb02') && $weight <=20000 && !(in_array($address['iso_code_2'], $countries))) {
				$cost = 0;

				$title_postnl = $this->language->get('text_title_wereld');
				$title = $this->language->get('text_postnl_wereld_aantekenen');

				$discount_postnl = 0;
				$postnl_discount_world_parcel_aan = $this->config->get('postnl_discount_world_parcel_aan');

				if ($weight > 0 && $weight <= 2000) {
					if (isset($postnl_discount_world_parcel_aan)) {
						$verzendkosten = $this->config->get('postnl_wereld_aantekenen_02');
						$discount_postnl = ($verzendkosten / 100) * $postnl_discount_world_parcel_aan;
						$verzendkosten = $verzendkosten - $discount_postnl;
					} else {
						$verzendkosten = $this->config->get('postnl_wereld_aantekenen_02');
					}
				}

				if ($weight > 2000 && $weight <= 5000) {
					if (isset($postnl_discount_world_parcel_aan)) {
						$verzendkosten = $this->config->get('postnl_wereld_aantekenen_05');
						$discount_postnl = ($verzendkosten / 100) * $postnl_discount_world_parcel_aan;
						$verzendkosten = $verzendkosten - $discount_postnl;
					} else {
						$verzendkosten = $this->config->get('postnl_wereld_aantekenen_05');
					}
				}

				if ($weight > 5000 && $weight <= 10000) {
					if (isset($postnl_discount_world_parcel_aan)) {
						$verzendkosten = $this->config->get('postnl_wereld_aantekenen_10');
						$discount_postnl = ($verzendkosten / 100) * $postnl_discount_world_parcel_aan;
						$verzendkosten = $verzendkosten - $discount_postnl;
					} else {
						$verzendkosten = $this->config->get('postnl_wereld_aantekenen_10');
					}
				}

				if ($weight > 10000 && $weight <= 20000) {
					if (isset($postnl_discount_world_parcel_aan)) {
						$verzendkosten = $this->config->get('postnl_wereld_aantekenen_20');
						$discount_postnl = ($verzendkosten / 100) * $postnl_discount_world_parcel_aan;
						$verzendkosten = $verzendkosten - $discount_postnl;
					} else {
						$verzendkosten = $this->config->get('postnl_wereld_aantekenen_20');
					}
				}

				if ($weight <= 0) {
					$error = $this->language->get('error_zero_weight');
				}

				if ($weight > 20000) {
					$error = $this->language->get('error_over_weight');
				}

				if ($this->config->get('postnl_display_weight')) {
					$title .= '<span class="help">' . $this->language->get('text_weight') . ' ' . $show_weight . ' ' . $kg . '</span>';
				}

				if ($this->config->get('postnl_display_time')) {
					$title .= $this->language->get('text_eta_ten');
				}

				$quote_data['postnl_wereld_aantekenen'] = array(
					'code' => 'postnl.postnl_wereld_aantekenen',
					'title' => $title,
					'cost' => $verzendkosten,
					'tax_class_id' => $this->config->get('postnl_tax_class_id'),
					'text' => $this->currency->format($this->tax->calculate($verzendkosten, $this->config->get('postnl_tax_class_id'), $this->config->get('config_tax')))
					);
			}

			// Rest van de wereld met Verzekering
			$countries = explode(',', 'NL,BE,DK,DE,FR,IT,LU,MC,AT,ES,GB,SE,BG,EE,FI,HU,IE,LV,LT,PL,PT,RO,SI,SK,CZ,
						   AL,AD,CH,VA,CY,BY,GI,GR,GL,IS,JE,HR,LI,MD,ME,MK,MT,NO,UA,SM,RS,TR,IM,GG,BA,FO');

			if ($this->config->get('postnl_wereld_rb03') && $weight <=20000 && !(in_array($address['iso_code_2'], $countries))) {
				$cost = 0;

				$title_postnl = $this->language->get('text_title_wereld');
				$title = $this->language->get('text_postnl_wereld_verzekerd');

				$discount_postnl = 0;
				$postnl_discount_world_parcel_ver = $this->config->get('postnl_discount_world_parcel_ver');

				if ($weight > 0 && $weight <= 2000) {
					if (isset($postnl_discount_world_parcel_ver)) {
						$verzendkosten = $this->config->get('postnl_wereld_verzekerd_02');
						$discount_postnl = ($verzendkosten / 100) * $postnl_discount_world_parcel_ver;
						$verzendkosten = $verzendkosten - $discount_postnl;
					} else {
						$verzendkosten = $this->config->get('postnl_wereld_verzekerd_02');
					}
				}

				if ($weight > 2000 && $weight <= 5000) {
					if (isset($postnl_discount_world_parcel_ver)) {
						$verzendkosten = $this->config->get('postnl_wereld_verzekerd_05');
						$discount_postnl = ($verzendkosten / 100) * $postnl_discount_world_parcel_ver;
						$verzendkosten = $verzendkosten - $discount_postnl;
					} else {
						$verzendkosten = $this->config->get('postnl_wereld_verzekerd_05');
					}
				}

				if ($weight > 5000 && $weight <= 10000) {
					if (isset($postnl_discount_world_parcel_ver)) {
						$verzendkosten = $this->config->get('postnl_wereld_verzekerd_10');
						$discount_postnl = ($verzendkosten / 100) * $postnl_discount_world_parcel_ver;
						$verzendkosten = $verzendkosten - $discount_postnl;
					} else {
						$verzendkosten = $this->config->get('postnl_wereld_verzekerd_10');
					}
				}

				if ($weight > 10000 && $weight <= 20000) {
					if (isset($postnl_discount_world_parcel_ver)) {
						$verzendkosten = $this->config->get('postnl_wereld_verzekerd_20');
						$discount_postnl = ($verzendkosten / 100) * $postnl_discount_world_parcel_ver;
						$verzendkosten = $verzendkosten - $discount_postnl;
					} else {
						$verzendkosten = $this->config->get('postnl_wereld_verzekerd_20');
					}
				}

				if ($weight <= 0) {
					$error = $this->language->get('error_zero_weight');
				}

				if ($weight > 20000) {
					$error = $this->language->get('error_over_weight');
				}

				if ($this->config->get('postnl_display_weight')) {
					$title .= '<span class="help">' . $this->language->get('text_weight') . ' ' . $show_weight . ' ' . $kg . '</span>';
				}

				if ($this->config->get('postnl_display_time')) {
					$title .= $this->language->get('text_eta_ten');
				}

				$quote_data['postnl_wereld_verzekerd'] = array(
					'code' => 'postnl.postnl_wereld_verzekerd',
					'title' => $title,
					'cost' => $verzendkosten,
					'tax_class_id' => $this->config->get('postnl_tax_class_id'),
					'text' => $this->currency->format($this->tax->calculate($verzendkosten, $this->config->get('postnl_tax_class_id'), $this->config->get('config_tax')))
					);
			}

		}
	}
		$method_data = array();

		if ($quote_data) {

			$method_data = array(
				'code' => 'postnl',
				'title' => $title_postnl,
				'quote' => $quote_data,
				'sort_order' => $this->config->get('postnl_sort_order'),
				'error' => $error
				);
		}
		return $method_data;
	}
}
?>